<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */

function smarty_function_grupyt_ext($params, &$smarty){

    $ext = true;
    if( isset($params['ext']) ){
        $ext = $params['ext'];
    }else{
        $params['ext'] = true;
    }
    $tree = $smarty->get_template_vars('drzewko');

    if ( empty($tree) ) {
        if( !class_exists('drzewko') ){
            require_once( INCLUDE_DIR . '/drzewko.class.php' );
        }

        $tree = new drzewko('towary', 0, true );
    }

    echo '<div class="cats">';
    echo '<div class="cat-all">Wszystkie</div>';
    smarty_function_grupyt_ext_print_cats( $tree->items[0]->items, $params );
    echo '</div>';
}

function smarty_function_grupyt_ext_print_cats( $cats, $options = array() ){
    $stos = array();
    $options = array_merge(array(
        'input' => null,
        'id' => null,
        'disabled' => false,
        'depth' => 0,
        'ext' => 0,
        'selected' => array()
    ), $options);

    if( !is_array($options['selected']) ){
        $options['selected'] = array();
    }
    extract($options);

    $depth = $options['depth'];
    $str_indent = '    ';
    $indent = str_repeat($str_indent, $depth);

    echo '<ul '.( $depth == 0 && $id ? 'id="'.$id.'"' : '' ).'>';
    foreach( $cats as $cat ){
        $endline = "\n";

        echo $indent . '<li>' . $endline;
        if ( $input ) {
            echo $indent . $str_indent . '<label class="'. ($cat->selected || in_array($cat->id, $selected) ? ' selected' : '' ).'" ><input type=checkbox name="'.$input.'" value="'.$cat->id.'" '.($cat->selected || in_array($cat->id, $selected) ? ' checked="checked"' : '' ).' style="margin:0"> ' . $cat->nazwa . '</label>' . $endline;
        } else {
            echo $indent . $str_indent . '<a href="'.URL_PATH.'/'.name2url($cat->nazwa). '-g'.$ext.'-'. $cat->id.'.html" class="'. ($cat->selected || in_array($cat->id, $selected) ? ' selected' : '' ).'" >' . $cat->nazwa . '</a>' . $endline;
        }

        if ( !empty( $cat->items ) ){
            $options['depth']++;
            smarty_function_grupyt_ext_print_cats( $cat->items, $options  );
        }
        echo $indent . '</li>' . $endline;
    }
    echo '</ul>';
}

