<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


function smarty_function_categories_select($params, &$smarty){

    $stos = array();

    $ext = $smarty->get_template_vars('ext');

    if( isset($params['tree']) ){
        $tree = $params['tree'];
    }else{
        $tree =& $smarty->get_template_vars('drzewko');

        if( empty($tree) ){
            if( !class_exists('drzewko') ){
                require( INCLUDE_DIR . '/drzewko.class.php' );
            }

            $gid = $smarty->get_template_vars('gid');

            $tree = new drzewko('towary', $gid, $ext );
        }
    }

    if( !empty($params['onchange']) ){
        $params['onchange'] = 'selectCategory(this, '.( !empty($ext) ? 'true' : 'false' ).' );';
    }else{
        $params['onchange'] = '';
    }

    $cats = array($tree->items[0]);
    $tree->items[0]->nazwa = 'Wybierz kategori';
    $cat = $tree->items[0];
    $cat_num = 0;
    $cats_count = 1;

    $output = '<select name="gid" '.( empty($params['onchange']) ? 'onchange="'.$params['onchange'].'"' : '' ).' size="1" style="'.$params['style'].'" >';
    while( !empty($cat) ){
        $indent = '';
        for( $i = 0; $i < $cat->depth; $i++ ) $indent .= '&nbsp;&nbsp; ';

        $output .= '<option value="'.$cat->id.'" '.($cat->selected? 'selected' : '' ).' >'.$indent. $cat->nazwa.'</option>';

        $cat_num++;

        if( !empty( $cat->items ) ){
            $stos[] = array(
                'cats' => $cats,
                'num'  => $cat_num,
                'count'  => $cats_count,
            );

            $cats = $cat->items;
            $cat  = $cat->items[0];
            $cat_num = 0;
            $cats_count = count($cats);

        }else if( $cat_num < $cats_count ) {
            $cat  = $cats[$cat_num];
        } else {
            $cat = null;

            while( $stos && !$cat ){
                $el = array_pop($stos);

                if ( $el ) {
                    $cats = $el['cats'];
                    $cat_num = $el['num'];
                    $cats_count = $el['count'];
                    $cat = isset($cats[$cat_num]) ? $cats[$cat_num] : null;
                }
            }
        }
    }

    $output .= '</select>';

    return $output;
}

