<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */

require_once('Cache/Lite.php');

function smarty_function_kupione_z_towarem($params, &$smarty){
    global $dbh1;

    $towar_id = 0;
    foreach( array('towar_id', 'id_towaru', 'towar', 'id' ) as $k ){
        if( isset($params[$k]) ){
            $towar_id = intval($params[$k]);
        }
    }

    if( empty($towar_id) ){
        return false;
    }


    // Create a Cache_Lite object
    $Cache_Lite = new Cache_Lite(array(
        'cacheDir' => TEMP_DIR . '/cache/', 'lifeTime' => 43200,
    ));

    $cache_id = 'plugin:kupione_z_towarem(' . $towar_id.')';
    if ( !($data = $Cache_Lite->get($cache_id)) && is_resource($dbh1) ) {
        // No valid cache found (you have to make the page)
        // Cache miss !
        $towary = array();

        //nalezy pobra wicej identyfikatorw towarw z tego wzgldu e moga trafi sie towary, ktre nie s
        //wywietlane w e-commerce i dla nich nie zostanie pobrana informacja przez funkcj towary_info
        $res = db_query($dbh1, 'SELECT FIRST 20 SKIP 0 ID_TOWARU, sum(ILOSC_PO) FROM GM_ZKPOZ WHERE ID_GLOWKI in ( SELECT DISTINCT ID_GLOWKI from gm_zkpoz WHERE ID_TOWARU = '.$towar_id.' ) and ID_TOWARU != '.$towar_id .' group by id_towaru order by 2 desc ' );
        if( $res ){
            while ( $row = ibase_fetch_row($res) ) {
                $towary[$row[0]] = $row[1];
            }
            ibase_free_result($res);
        }

        if ( $towary ) {
            $towary_info = towary_info( array_keys($towary), array(
                //informacja o producencie
                'producent' => true,
                //informacja i promocji i cenie promocyjnej
                'promocja'  => true,
                //informacja i wyprzedazy i cenie dla wyprzedazy
                'wyprzedaz' => true,
                //informacja o stanie towaru
                'dostepnosc' => true,
                //informacja o zdjeciu
                'zdjecie' => true,
                'priorytet_cen' => false,
                //jesli towar ma cene promocyjna wwczas zostanie ona wpisana do pola CENA i CENA_BRUTTO towaru
                'ceny_promocyjne' => false,
            ));

            $towary = $towary_info['towary'];
        }
        
        $Cache_Lite->save(serialize($towary));
    } else if( $data ){
        $towary = unserialize( $data );
    }else{
        return;
    }
    
    //mozna przekazac do szablonu i wywietlanie zrealizowa w szablonie
    $smarty->assign_by_ref( 'towary_zamowione', $towary );

    $output = '';
    if ( $towary ) {
        $SZABLON_URL = $smarty->get_template_vars('SZABLON_URL');
        
        $output .= '<h3>Klienci, ktrzy kupili ten twar kupili rwnie: </h3>';

        //wywietlam maksymalnie 10 towarw
        $output .= '<table class="data" width="95%" cellspacing="0" cellpadding="2" border="0">'."\n";
        $output .= '<tr class="head">'."\n";
        $output .= '   <th width="20px">Lp.</th>'."\n";
        $output .= '   <th colspan="2">Nazwa</th>'."\n";
        $output .= '   <th width="10%" >Cena</th>'."\n";
        $output .= '	 <th width="15%" >Opis</th>'."\n";
        $output .= '</tr>'."\n";
        
        for ( $j = $i = 0, $lp = count($towary); $i < $lp && $j < 10 ; $i++ ) {
          if ( !empty($towary[$i]['CENA_BRUTTO']) ){
            $j++;
            
            $towar_url = URL_PATH.'/'.$towary[$i]['NAZWA_URL'].'-t-'.$towary[$i]['ID'].'.html';

            $output .= '<tr class="'.( $i % 2 ? 'odd' : 'even' ).'" >'."\n";
            $output .= '   <td align=right><a class="product" href="'.$towar_url.'">'.($j).'.</a> </div></td>'."\n";
            $output .= '   <td width="25px" style="padding:5px 10px;"><a href="'.$towar_url.'"><img class="obrazek micro" src="'.IMAGES_URL.'/obrazki/mini/'.$towary[$i]['RYSUNEK'].'.jpg" onmouseover="img_preview_show_no_ajax( this, \''.IMAGES_URL.'/obrazki/small/'.$towary[$i]['RYSUNEK'].'.jpg\', \'\', \'\')" onmouseout="img_preview_hide();" alt="" /></a></td>'."\n";
            $output .= '   <td>'."\n";
            if( $towary[$i]['PRODUCENT'] ){
                $output .= '     <a class="product" href="'.URL_PATH.'/'.$towary[$i]['PRODUCENT_NAZWA_URL'].'-p-'.$towary[$i]['PRODUCENT'].'.html">'.$towary[$i]['PRODUCENT_NAZWA'].'</a><br />'."\n";
            }
            $output .= '     <a href="'.$towar_url.'">'.$towary[$i]['NAZWA'].'</a><br>'."\n";
            $output .= '   </td>'."\n";
            $output .= '   <td align=right><b title="cena brutto">'.currency_format($towary[$i]['CENA_BRUTTO']).'</b><br /><small title="cena netto">'.currency_format($towary[$i]['CENA']).'</small></td>'."\n";
            $output .= '   <td align="center">'."\n";

            if ( $towary[$i]['OBRAZ'] ) {
                $output .= '     <img title="Ze zdjciem" src="'.$SZABLON_URL.'/images/icons/ico-obraz.png" alt="" />'."\n";
            }

            if ( $towary[$i]['UWAGI'] ) {
                $output .= '     <img title="Z opisem" src="'.$SZABLON_URL.'/images/icons/ico-opis.png" alt="" />'."\n";
            }

            if ( $towary[$i]['ILOSC'] ) {
                $output .= '     <img title="Z opisem" src="'.$SZABLON_URL.'/images/icons/ico-jest.png" alt="" />'."\n";
            } else {
                $output .= '     <img title="Z opisem" src="'.$SZABLON_URL.'/images/icons/ico-brak.png" alt="" />'."\n";
            }

            if ( $towary[$i]['PROMOCJA'] ) {
                $output .= '     <img title="Z opisem" src="'.$SZABLON_URL.'/images/icons/ico-promo.png" alt="" />'."\n";
            }

            $output .= '   </td>'."\n";
            $output .= '</tr>'."\n";
            
          }
        }
        $output .= '</table>';
    }

    return $output;
}
/***************************************************************************************************
 *
 *  Przykad jak mozna wyswietlic towary zamawiane z danym produktem w szablonach smarty
 *
 */
 
/*
<h3>Klienci, ktrzy kupili ten twar kupili rwnie: </h3>

<table class="data" cellpadding="0" cellspacing="0" >
  <tr class="head">
      <th colspan="2">Nazwa</th>
      <th width="10%" >Cena</th>
	  <th width="15%" >Opis</th>
  </tr>

  {foreach from=$towary_zamowione item=towar name=towary_zamowione}
   <tr class={cycle values="odd,even"} >
      <td width="25px" style="padding:5px 10px;"> <a href="{$MAIN_URL}/action_towar/mode_show/ID_{$akcesorium.ID}/{$towar.NAZWA_URL}"><img class = "obrazek micro" src='{$IMAGES_URL}/obrazki/mini/{$towar.RYSUNEK}.jpg' onmouseover="img_preview_show_no_ajax( this, '{$IMAGES_URL}/obrazki/small/{$towar.RYSUNEK}.jpg', '', '')" onmouseout="img_preview_hide();" alt=''></a> </td>
      <td ><a href='{$MAIN_URL}?action=towar&amp;mode=show&amp;ID={$towar.ID}' >{$towar.NAZWA}</a></td>
      <td align=right><b title="cena brutto">{$towar.CENA_BRUTTO|currency_format}</b><br /><small title="cena netto">{$towar.CENA|currency_format}</small></td>
      <td  align='center'>
       {if $towar.RYSUNEK }<img title="Ze zdjciem" src='{$SZABLON_DIR}/images/icons/ico-obraz.png' alt=''> {/if}
  	   {if $towar.UWAGI } <img title="Z opisem" src='{$SZABLON_DIR}/images/icons/ico-opis.png' alt=''> {/if}
       {if $towar.ILOSC } <img title="Brak w magazynie" src='{$SZABLON_DIR}/images/icons/ico-brak.png' alt=''> {else} <img title="Jest w magazynie" src='{$SZABLON_DIR}/images/icons/ico-jest.png'> {/if}
  	   {if $towar.PROMOCJA } <img title="W promocji" src='{$SZABLON_DIR}/images/icons/ico-promo.png' alt=''> {/if}
      </td>
    </tr>
  {/foreach}
  
  <tr>
    <td colspan="4">
      {include file="legenda.tpl"}
    </td>
  </tr>
</table>

*/
