/**************************************************************************************************/

function Docs( settings ){

    if( settings['prefix'] ){
        this.prefix = settings['prefix'];
    }else{
        this.prefix = new String("");
    }

    this.max = 5;
    if( settings['max'] > 0 ){
        this.max = settings['max'];
    }

    if( this.prefix && this.prefix.substring( this.prefix.length - 1 ) != "_" ){
        this.prefix += '_';
    }

    if( !settings.var_name ){
        settings.var_name = 'o_' + this.prefix + 'docs';
    }
    this.var_name = settings['var_name'];

    if( !settings.div_id ){
        settings.div_id = this.prefix + 'docs_div';
    }

    this.o_div = document.getElementById( settings.div_id );

    if( !this.o_div ){
        settings.div_id = this.prefix + 'docs_list_div';
        this.o_div = document.getElementById( settings.div_id );
        
        if( !this.o_div ){
            alert('Bd krytyczny. Nie znaleziono elementu w dokumencie o id: ' + settings.div_id  );
            return false;
        }
    }

    this.o_table = null;

    this.a_items = new Array();
    this.n_item = -1;
    this.mode   = 'add';
    this.b_show_form = false;
    this.o_grid = null;

    this.n_file = 0;

    if( settings.items ){
        this.a_items = settings.items;
    }

    this.o_form_div = document.getElementById( this.prefix + 'doc_form_div');

    var formularz = ( settings.form_name) ? settings.form_name : this.prefix + 'doc_form';
    this.o_form = document.forms[formularz];
    if( !this.o_form ){
        alert('Bd krytyczny. Nie znaleziono w dokumencie formularza: ' + formularz  );
        return false;
    }

    this.o_usun_btn =  document.getElementById( this.prefix + 'doc_usun_btn');
    this.o_preview_div =  document.getElementById( this.prefix + 'doc_preview');

    //pole w formularzu jak bd si nazywa zaanczane doc
    this.s_form_field = ( settings.form_field) ? settings.form_field : this.prefix + 'docs';
    //jest to nazw do tablicy _FILE w php do kolejnych docw dostaniemy seu _FILE[this.s_file_input_name.'_'.$num]
    this.s_file_input_name = ( settings.file_input_name) ? settings.file_input_name : this.prefix + 'doc';

    this.show_form = doc_show_form;
    this.anuluj = doc_anuluj;

    this.init  = docs_init;
    this.make_tr = Docs_make_tr;
    this.print = Docs_print;

    this.add_edit = doc_add_edit;

    this.usun   = doc_usun;

    this.up = doc_up;
    this.down = doc_down;

    this.init();
}

function docs_init(){
    this.o_table = document.createElement('TABLE');
    this.o_table.id = this.prefix + 'docs_grid';
    this.o_table.className = 'grid';
    this.o_table.style.width = '100%';
    this.o_table.cellPadding = 2;
    this.o_table.cellSpacing = 0;

    o_tbody = document.createElement('TBODY');

    o_tr = document.createElement('TR');
    var o_td = document.createElement('TH');
    o_td.innerHTML = 'Lp.';
    o_td.width = '20px';
    o_tr.appendChild(o_td);

    o_td = document.createElement('TH');
    o_td.appendChild( document.createTextNode('Wymagany'));
    o_td.width = '50px';
    o_tr.appendChild(o_td);

    o_td = document.createElement('TH');
    o_td.appendChild( document.createTextNode('Dokument'));
    o_tr.appendChild(o_td);

    o_tbody.appendChild(o_tr);

    this.o_table.appendChild(o_tbody);
    this.o_div.innerHTML = "";
    this.o_div.appendChild( this.o_table );

    this.o_msg_div = document.createElement('div');
    if( this.o_div.nextSibling ){
        this.o_div.parentNode.insertBefore( this.o_msg_div, this.o_div.nextSibling);
    }else{
        this.o_div.parentNode.appendChild( this.o_msg_div);

    }

    if( this.a_items.length > 0 ){
         this.print();
    }
}

function doc_show_form( action ){
    var o_self = this;

    this.mode = action;

    if( action == 'edit' ){
        if( this.o_usun_btn ) this.o_usun_btn.style.display = '';

        if( arguments.length > 1 ){
            this.n_item = arguments[1];
        }

        if( this.n_item  < 0 ){
            alert('Kliknij dwa razy na zacznik aby go edytowa lub kliknij raz na towar_opakowanie, a nastpnie wcinij przycisk edycja.');

            return;
        }else if(this.n_item  > this.a_items.length ){
            this.n_item = this.a_items.length;
        }
    }else{
        if( this.o_usun_btn ) this.o_usun_btn.style.display = 'none';

        this.n_item = this.a_items.length;
    }

    try{ showTlo(); }catch(e){ }

/******************************************************************************/

    if( typeof(this.a_items[this.n_item]) == 'object' ){
        var o_item = this.a_items[this.n_item];

        if( this.o_form.elements.wymagany )
            this.o_form.elements['wymagany'].checked = (o_item.wymagany == 1);

        this.o_form.elements['rozszerzenia'].value = o_item.rozszerzenia;
        this.o_form.elements['nazwa'].value = o_item.nazwa;

        if( this.a_items[this.n_item].file_input ){
            var o_finput = this.a_items[this.n_item].file_input.cloneNode(true);
            o_finput.name = 'doc';
            o_finput.style.display = '';

            this.o_form.elements['doc'].parentNode.replaceChild(o_finput, this.o_form.elements['doc'] );
        }
    }

    center_both_obj( this.o_form_div );

    this.o_form.elements['nazwa'].focus();

    add_event( 'keydown', document, function( e ){
        e = (!e) ? window.event : e;

        // pobiera kod znaku nacinitego klawisza
        var code = (e.charCode) ? e.charCode :((e.keyCode) ? e.keyCode :((e.which) ? e.which : 0));

        if( code == 27 ){
            o_self.anuluj();
        }
    }, false );

    this.b_show_form = true;

/******************************************************************************/

}

function doc_anuluj(){

    if( this.mode == 'edit' ){
        this.o_form.reset();
    }

    remove_event( 'keydown', document );

    hide_obj( this.o_form_div );

    try{ hideTlo(); }catch(e){}

    this.b_show_form = false;
}




function doc_usun( num, o_tr ){
    var o_self = this;

    if( arguments.length  > 0 ){
        this.n_item = num;
    }
    if( arguments.length  < 2 ){
        var o_tr_list = this.o_table.getElementsByTagName('TR');
        o_tr = o_tr_list.item(this.n_item+1);
    }

    this.o_tr = o_tr;

    if( this.n_item <  0 || this.n_item >= this.a_items.length ){
        alert('Kliknij najpierw na zaacznik, a nastpnie wcinij klawisz delete lub przyscisk usu.');
        return;
    }

    if( !confirm('Jeste pewien, e chcesz usun zacznik?' ) ){
        return;
    }

    var o_item = this.a_items.splice(this.n_item, 1);

    if( this.n_item >= this.a_items.length ){
        var o_tr_new = o_tr.previousSibling;

        this.n_item = this.a_items.length - 1;

        o_tr.parentNode.removeChild( o_tr );

        if( this.n_item >= 0 ){
            podswietl_wiersz( o_tr_new );
        }
    }else{
        var o_tr_new = o_tr.nextSibling;

        o_tr.parentNode.removeChild( o_tr );

        var o_td, i  = this.n_item;

        var o_tr_highlight = o_tr_new;

        while( o_tr_new ){
            //console.log(o_tr.nodeName);

            if( o_tr_new.nodeName == 'TR' ){
                o_td = o_tr_new.firstChild;
                o_td.innerHTML = (i+1) + '. ';
                o_tr_new.className = 'wiersz' + ( (i%2) + 1 );

                var num = i;

                o_tr_new.onclick = function(){
                    o_self.n_item = num;
                    podswietl_wiersz( this );
                };
                o_tr_new.ondblclick = function(){
                    o_self.show_form('edit', num);
                };

                i++;
            }

            o_tr_new = o_tr_new.nextSibling;
        }

        podswietl_wiersz( o_tr_highlight );
    }

    if( this.b_show_form ){
        this.anuluj();
    }

    

/*
    if( this.o_form ){
        var o_input  = document.createElement('INPUT');
        o_input.type  = 'hidden';
        o_input.name  = 'docs2delete[]';
        o_input.value = o_item['ID'];

        this.o_form.appendChild( o_input );
    }
*/
}

function doc_up( num, o_tr ){
    var o_self = this;

    if( arguments.length  > 0 ){
        this.n_item = num;
    }
    if( arguments.length  < 2 ){
        var o_tr_list = this.o_table.getElementsByTagName('TR');
        o_tr = o_tr_list.item(this.n_item+1);
        console.log('dsfdsfsda');
    }

    this.o_tr = o_tr;

    if( this.n_item <  0 || this.n_item >= this.a_items.length ){
        alert('Kliknij najpierw na doc, a nastpnie wcinij klawisz ctr+up lub przyscisk do gry.');
        return;
    }

    if( this.n_item > 0 ){
        var o_item = this.a_items[this.n_item];
        this.a_items[this.n_item] = this.a_items[this.n_item-1];
        this.a_items[this.n_item-1] = o_item;

        var o_tr_prev = o_tr.previousSibling;
        o_tr.parentNode.removeChild( o_tr );
        o_tr_prev.parentNode.insertBefore( o_tr, o_tr_prev );

        var o_tr_new, i, lp;
        var a_array = [o_tr, o_tr_prev ];

        this.n_item--;

        for( i = 0; i < 2; i++ ){
            o_tr_new = a_array[i];
            lp = this.n_item + i;

            o_tr_new.firstChild.innerHTML = (lp+1) + '. ';
            o_tr_new.className = 'wiersz' + ( (lp%2) + 1 );
        }
        podswietl_wiersz(o_tr);
    }else{
        alert('Nie mona przesun docu do gry.');
    }

    if( this.b_show_form ){
        this.anuluj();
    }
}

function doc_down( num, o_tr ){
    var o_self = this;

    if( arguments.length  > 0 ){
        this.n_item = num;
    }
    if( arguments.length  < 2 ){
        var o_tr_list = this.o_table.getElementsByTagName('TR');
        o_tr = o_tr_list.item(this.n_item+1);
    }

    this.o_tr = o_tr;

    if( this.n_item <  0 || this.n_item >= this.a_items.length ){
        alert('Kliknij najpierw na doc, a nastpnie wcinij klawisz ctr+down lub przyscisk "do dou".');
        return;
    }


    if( this.n_item < this.a_items.length - 1){
        var o_item = this.a_items[this.n_item];
        this.a_items[this.n_item] = this.a_items[this.n_item+1];
        this.a_items[this.n_item+1] = o_item;

        var o_tr_next = o_tr.nextSibling;
        o_tr.parentNode.removeChild( o_tr );

        if( o_tr_next.nextSibling ){
            o_tr_next.parentNode.insertBefore( o_tr, o_tr_next.nextSibling );
        }else{
            o_tr_next.parentNode.appendChild( o_tr );
        }

        var o_td, o_tr_new, i, lp;
        var a_array = [o_tr_next, o_tr];

        for( i = 0; i < 2; i++ ){
            o_tr_new = a_array[i];
            lp = this.n_item + i;

            o_tr_new.firstChild.innerHTML = (lp+1) + '. ';
            o_tr_new.className = 'wiersz' + ( (lp%2) + 1 );
        }
        this.n_item++;

        podswietl_wiersz(o_tr);
    }else{
        alert('Nie mona przesun docu do dou.');
    }

    if( this.b_show_form ){
        this.anuluj();
    }
}


function doc_add_edit(){
    var nazwa, rozszerzenia, wymagany = 0;
    
    if (  this.a_items.length >= this.max ){
        alert('Na licie jest ju '+this.max+' dokumentw. eby doda inny, usu ktry z listy.');
        return false;
    }

    var nazwa, rozszerzenia, wymagany = 0;
    
    nazwa = this.o_form.elements.nazwa.value;
    if( nazwa == "" ){
        alert('Podaj nazw dokumentu.');
        return false;
    }
    
    rozszerzenia = this.o_form.elements.rozszerzenia.value;
    if( rozszerzenia == "" ){
        alert('Podaj dozwolone rozszerzenia rozdzielone rednikiem.');
        return false;
    }

    if( this.o_form.elements.wymagany )
        wymagany = (this.o_form.elements.wymagany.checked ? 1 :0);


    this.n_file++

    var o_item = {
        'nazwa'       : nazwa,
        'rozszerzenia': rozszerzenia,
        'wymagany'    : wymagany
//        'zmieniony'   : 1
    };


    var o_tr = null;
    if( (this.n_item+1) < this.o_table.rows.length  ){
        for( var a in o_item ){
            this.a_items[this.n_item][a] = o_item[a];
        }

        o_tr = this.o_table.rows[this.n_item+1];
        while ( o_tr.childNodes.length >= 1 ){
            o_tr.removeChild( o_tr.firstChild );
        }
        this.make_tr( o_tr, this.n_item );
    }else{
        this.a_items[this.n_item] = o_item;

        o_tr = document.createElement('TR');
        this.make_tr( o_tr, this.n_item );
        this.o_table.firstChild.appendChild( o_tr );
    }

    if( this.b_show_form ){
        this.o_form.reset();
        this.anuluj();
    }
}


function Docs_make_tr( o_tr, i ){
    var o_doc = this.a_items[i];

    var o_td = document.createElement('TD');
    o_td.appendChild(document.createTextNode(( i + 1 )+ "."));

    var o_input = null;

    var t = ['nazwa', 'rozszerzenia', 'wymagany' ];
    for( a  in o_doc  ){
        if( typeof(o_doc[a]) !== 'object'  ){
            o_input = document.createElement('input');
            o_input.type='hidden'
            o_input.name  = this.s_form_field + '[' + i +']['+ a +']';
            o_input.value = o_doc[a];
            o_td.appendChild( o_input );
        }
    }

    o_tr.appendChild(o_td);

    o_td = document.createElement('TD');
    o_td.align ="center";
    o_td.appendChild(document.createTextNode(o_doc.wymagany == 1 ? 'Tak' : 'Nie' ));
    o_tr.appendChild(o_td);

    o_td = document.createElement('TD');
    o_td.appendChild(document.createTextNode(o_doc.nazwa));
    o_tr.appendChild(o_td);

    var o_self = this;
    o_tr.onclick = function(){
        o_self.n_item = this.rowIndex-1;
        podswietl_wiersz( this );
    }

    o_tr.ondblclick = function(){
        o_self.show_form('edit', this.rowIndex-1);
    }

    o_tr.className = 'wiersz' +(i%2+1);
}


function Docs_print(){
    var i, o_tbody, o_tr = false;

    var o_self = this;

    var o_tr = null;
    var o_tr_highlight = null;

    o_tbody = this.o_table.firstChild;

    for( i = 0; i < this.a_items.length; i++ ){
        o_tr = document.createElement('TR');
        this.make_tr( o_tr, i );
        o_tbody.appendChild( o_tr );

        if( i == this.n_item ){
            o_tr_highlight = o_tr;
            o_tr.className += ' highlight';
        }
    }

    podswietl_wiersz( o_tr_highlight );
    
/**************************************************************************************************/

    grid_settings = {
        'ondelete' : function(){ o_self.usun(arguments[0], arguments[1]) },
        'onctrlup' : function(){ o_self.up(arguments[0], arguments[1]) },
        'onctrldown' : function(){ o_self.down(arguments[0], arguments[1]) }
    }


    grid_settings.onenter = function(){ o_self.show_form('edit', arguments[0], arguments[1]) };
    grid_settings.oninsert = function(){ o_self.show_form('add') };


    this.o_grid = new Grid( this.prefix + 'docs_grid', grid_settings);
}

/**************************************************************************************************/

