/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */


var Inpost = {
    'config' : '', //nazwa aktywnej konfiguracji
    'kurier' : null,
    'settings' : null,
    'template' : null,
    'templates' : null,
    'parcels' : [], //aktualne paczki, pocztkowa pusta lista
    'parcelIndex': -1, //aktualnie zmieniana paczka
    'parcelTypes': {},
    'doc_type' : 'zk',
    'options' : [], //opcje do selecta
    'docs' : [] //opcje do selecta
};


(function(){
    var $settingsDialog, $inpostPaczki, $pickupDialog, $shipmentDialog, $parcelDialog, $settingsValidator, $shipmentValidator, $dialog, $activeDialog, docSelection;

    var dialogOptions = {
          title: '',
          bgiframe: true,
          show: 'clip',
          hide: 'clip',
          width: 'auto',
          height: 'auto',
          minWidth: 300,
          minHeight: 100,
          maxWidth: 800,
          closeOnEscape: true,
          autoOpen: false,
          modal: false,
          draggable: true,
          'open': function(event, ui) {
              showTlo();
          },
          'close': function(){
              hideTlo();
          }
    };

    var metadataOptions = {
        type: 'attr',
        name: 'data'
    }

/**************************************************************************************************/
    function __html_replace( html, data, prefix ){
        if ( !prefix ) prefix = '%';

        if ( html && typeof(data) == 'object') {
            for ( var key in data ){
                 if ( typeof(data[key]) == 'object' ){
                    html = __html_replace( html, data[key], prefix + key + '\\.' );
                }else if ( typeof(data[key]) == 'string' || typeof(data[key]) == 'number' ){
                    html = html.replace(new RegExp( prefix + key + '%','g'), data[key]);
                }
            }
        }

        return html;
    }

    function print_object( template, data ){
        var html = jQuery(template).clone(false).removeClass('template').show().wrap('<div></div>');

        html = __html_replace( html.parent().html(), data );
        html = html.replace(new RegExp( '%[a-zA-Z0-9_\\.\\-]+%','g'), '&nbsp;');

        return html;
    }

    function save_object( data, options ){//wstawia obiekt zwrcony z serwera do HTML
        var html = print_object('#'+ options.model_parent + ' ' + ( options.tpl ? options.tpl : '.tpl') , data);

        if ( empty(html) ) {
            console.log('Nie znaleziono obiektu: ' + '#' + options.model_parent + ' .tpl');
            return false;
        }

        var insert = jQuery(html);
        if( options.attach_handlers && typeof(options.attach_handlers) == 'function' ){
            try{
                options.attach_handlers(insert);
            }catch(err){
                if ( console && console.log && typeof(console.log) == 'function' ){
                    console.log(err);
                }
            }
        }

        if ( options.mode && (options.mode == 'edit' || options.mode == 'update') ) {
            jQuery( '#' + options.model + data.id ).replaceWith(insert);
        } else {
            insert.css("display", "none");
            jQuery( '#'+ options.model_parent ).append(insert);
            insert.fadeIn("slow");
        }
    }

    /**
     * Czysci formularz z bdw i jesli s jakie pola z klas valid rwnie j usuwa
     *
     * @param {type} $form
     * @returns {undefined}
     */
    function validatorClearForm( $form, reset ){
        if ( reset ) {
            $form.validate().resetForm();
        }

        $('.valid', $form).removeClass('valid');
        $('input.error, select.error, textarea.error', $form).removeClass('error');
        $('label.error', $form).hide();
    }

/**************************************************************************************************/

    var settingsAjax = {
        error: function(jqXHR, textStatus, errorThrown){
            //console.log(textStatus);
            //console.log(jqXHR);
            //console.log(errorThrown);

            hideLoading();
            print_message( 'Przez serwer zostaa zwrcona nieprawidowa odpowied' );

            if ( $activeDialog ) {
                $activeDialog.dialog("enable");
                $activeDialog.dialog("close");
                $activeDialog = null;
            }
        },

        beforeSubmit:  function(){
            if( $activeDialog ){
                $activeDialog.dialog("disable");
            }
            showLoading(0, 0, 1100);
        }
    }

    function settingsOptions() {
        var $select = $('#inpostSettingsDialog').find('select[name=config]');
        var option = null, update = false;

        if( !Inpost.options ){
            Inpost.options = [];
        }

        if ( Inpost.settings && (!Inpost.options || Inpost.options.length == 0) ) {
            Inpost.options = [];
            for( var o in Inpost.settings ){
                if( typeof(Inpost.settings[o]) == 'object' ){
                    Inpost.options.push(o) ;
                }
            }

            update = true;
        }

        if ( !$select.val() ) {
            option = $('#inpostSettingsDialog').find('input[name=nazwa]').val();
        }

        if ( option ) {
            Inpost.options.push(option);

            update = true;
        }

        if ( update ) {
            $select.children('option:gt(0)').remove();

            Inpost.options.sort();
            for ( var i = 0; i < Inpost.options.length ; i++ ) {
                $select.append('<option value="' + Inpost.options[i]+ '">' + Inpost.options[i] + '</option>');
            }
        }
    }

    function settingsOpen( e ){
        e.preventDefault();

        if ( !$settingsDialog ) {

            var dialogOpcje = $.extend({}, dialogOptions, {
                title: 'Konfiguracja autoryzacji do API firmy INPOST',
                buttons: [
                    {
                        text: "Anuluj",
                        icons : {
                            'primary' : 'ui-icon-cancel'
                        },
                        click: function() {$(this).dialog("close");}
                    },
                    {
                        text: "Usu",
                        icons : {
                            primary : 'ui-icon-trash'
                        },
                        click: settingsDelete
                    },
                    {
                        text: "Zapisz",
                        icons : {
                            primary : 'ui-icon-disk'
                        },
                        click: function() {
                            $(this).find("form").submit();
                        }
                    }
                ],
                open: function(){
                    validatorClearForm($('form', this));
                }
            });



            $settingsDialog = $('#inpostSettingsDialog').dialog( dialogOpcje );

            $settingsDialog.find('input[type=submit]').hide();

            $settingsDialog.find('.set-btn').button({
                'icons' : {
                    'primary' : 'ui-icon-circle-check'
                },
                'text' : false
            }).click(settingsSet);

            $settingsDialog.find('select[name=config]').change(settingsSelect);

            $settingsDialog.find('input[name=test]').click(function(){
                if ( this.checked ) {
                    if ( !$settingsDialog.find('input[name=username]').val() ) {
                        $settingsDialog.find('input[name=username]').val('demo');
                    }

                    if ( !$settingsDialog.find('input[name=password]').val() ) {
                        $settingsDialog.find('input[name=password]').val('demo');
                    }
                }
            });

            settingsOptions();

            $settingsValidator = $settingsDialog.find('form').validate({
                submitHandler: settingsSave,
            });
        }

        //aktualizuje list szablonw do wyboru
        templateOptions($settingsDialog.find('select[name=template]'));

        if ( Inpost.config ) {
            $settingsDialog.find('select[name=config]').val(Inpost.config);
            $settingsDialog.find('select[name=config]').change();
        }

        $settingsDialog.dialog('open');

        return false;
    }

    function settingsSave( form ) {
        $activeDialog = $settingsDialog;

        jQuery(form).ajaxSubmit($.extend({},settingsAjax, {
            dataType:  'json',

            success: function(data){
                hideLoading();
                $settingsDialog.dialog( "enable" );

                print_message( data );

                if ( !data.error ) {
                    settingsOptions();
                    settingsUpdate();

                    $('.clearable', form).clearFields();

                    $settingsDialog.dialog("close");
                    $activeDialog = null;
                } else {
                    $settingsValidator.showErrors(data.object);
                }
            }
        }));
    }

    function settingsSet( e ){
        e.preventDefault();

        var config = $('#inpostSettingsDialog input[name=nazwa]').val();

        if ( !config || config == '' ) {
            print_message( 'Wybierz konfiguracj ktr chcesz uzywa do polczenia si z API firmy INPOST' );
            return false;
        }

        $.ajax($.extend({},settingsAjax, {
            'url': this.href,
            'dataType':  'json',
            'data':  {'config' : config},

            'success': function(data){
                hideLoading();
                $settingsDialog.dialog( "enable" );

                print_message( data );

                if ( !data.error ) {
                    settingsUpdate()
                }
            }
        }));

        //console.log(settingsAjax);

        return false;
    }

    function settingsDelete( e ){
        e.preventDefault();

        var config = $('#inpostSettingsDialog input[name=nazwa]').val();

        if ( !config ) {
            print_message( 'Wybierz konfiguracj ktr chcesz usun' );
            return false;
        }
        var mode = $('#inpostSettingsDialog input[name=mode]').val();

        $.ajax($.extend({}, settingsAjax, {
            'url': Inpost.url,
            'dataType':  'json',
            'data':  {'mode' : mode, 'delete' : config},

            'success': function(data) {
                hideLoading();
                $settingsDialog.dialog( "enable" );

                print_message( data );

                if ( !data.error ) {
                    if ( config && Inpost.settings[config] ){
                        delete Inpost.settings[config];
                        $('#inpostSettingsDialog form').clearForm();
                        Inpost.options = [];
                        settingsOptions();
                    }
                }
            }
        }));

        return false;
    }

    function formSetValues( form, data, opcje ) {
        var $form = $(form), el = '', is_text = false;

        if ( typeof(opcje) == 'undefined' ){
            opcje = {};
        }

        if ( typeof(opcje) != 'object' ){
            opcje = {'clear' : opcje};
        }

        opcje  = $.extend({
            'clear' : false,
            'prefix' : '',
            'sufix' : ''
        }, opcje);

        if ( opcje.clear ) {
            if ( typeof(opcje.clear) == 'object' ) {
                opcje.clear.clearFields();
                //console.log( data );
//                for( var i = 0; i < opcje.clear.length; i++ ){
//                    console.log( (i+1) + '. ' + opcje.clear[i].name );
//                }
            } else if ( typeof(opcje.clear) == 'string' ) {
                $form.find(opcje.clear).clearFields();
            }else{
                $form.clearForm();
            }

            $form.find('input[title]').each(function(){
                if( (!this.value || this.value == '') && this.title ){
                    this.value = this.title;
                }
            });
        }

        if ( typeof(data) == 'object' ){
            for ( var f in data ) {
                el = opcje.prefix + f + opcje.sufix;
                //console.log('el: ' + el + ' = ' + data[f] );
                if ( typeof(data[f]) == 'object' ) {
                    formSetValues(form, data[f], {
                        'prefix' : el + '[',
                        'sufix' : ']'
                    });
                } else if ( form.elements[el] ) {
                    if ( form.elements[el].type == 'checkbox' ) {
                        form.elements[el].checked = (data[f] > 0);
                    } else {
                        if ( form.elements[el].type == 'text' || form.elements[el].type == 'textarea' || (form.elements[el].tagName && form.elements[el].tagName.toLowerCase() == 'textarea') ) {
                            is_text = true;
                        } else {
                            is_text = false;
                        }

                        if ( typeof(data[f]) == 'boolean' && data[f] === false && is_text ) {
                            $(form.elements[el]).val('');
                        } else {
                            $(form.elements[el]).val(data[f]);
                        }
                    }
                }
            }
        }

    }

    function object_deflatte ( fData ) {
        var object = new Object(), deflatte = {}, pos, k, p;

        for ( var f in fData ) {
            pos = f.indexOf('[');

            if ( pos > -1 ) {
                k = f.substring(0, pos);
                p = f.substring(pos + 1, f.indexOf(']') );
                if ( typeof(object[k]) == 'undefined' ) {
                    object[k] = {};
                }

                object[k][p] = fData[f];

                if ( p.indexOf('[') > -1 && typeof(deflatte[k]) == 'undefined' ){
                    deflatte[k];
                }
            } else {
                object[f] = fData[f];
            }
        }

        for ( k in deflatte ) {
            object[k] = object_deflatte( object[k] );
        }

        return object;
    }

    function formGetValues( form ) {
        var $form = $(form), data = new Object();

        var some_data = $form.find("input, select, textarea").map(function(){
            return {'name': $(this).attr('name'), 'value': ( this.type && this.type == 'checkbox' ) ? (this.checked ? '0' : this.value) : $(this).val()};
        }).get();

        for ( var i = 0; i < some_data.length; i++  ) {
            if ( some_data[i].name ) {
                data[some_data[i].name] = some_data[i].value;
            }
        }

        data = object_deflatte( data );

        //console.log(data);
        return data;
    }

    function settingsSelect(){
        var clear = true;

        if ( this.value ) {
            if ( Inpost && Inpost.settings && Inpost.settings[this.value] ) {
                formSetValues(this.form, Inpost.settings[this.value], {'clear' : false});
                clear = false;
            }
        }

        if ( clear ) {
            $(this.form).clearForm();
        }
    }

    function settingsUpdate(){
        var $settingsInputs = $('#inpostSettingsDialog input').not('[type=hidden]').not('[type=submit]').not('[type=image]');
        var settingsList = [];

        $settingsInputs.each(function(){
            var value = null;

            if( this.type == 'checkbox' ){
                value = (this.checked ? this.value : '');
            } else {
                value = this.value;
            }

            settingsList.push({'name' : this.name, 'value' : value});
            return true;
        });

        var i, settings = {};
        for ( i = 0 ;  i < settingsList.length; i++ ){
            if( settingsList[i].name ){
                settings[settingsList[i].name] = settingsList[i].value;
            }
        }

        Inpost.config = settings.nazwa;

        //aktualizuje ustawienia w settingasach
        if ( !Inpost.settings || typeof(Inpost.settings) != 'object' ){
            Inpost.settings = {};
        }

        Inpost.settings[settings.nazwa] = settings;
        if ( settings.domyslny ) {
            for( var f in Inpost.settings ){
                if( f != settings.nazwa ) {
                    Inpost.settings[f].domyslny = '';
                }
            }
        }

        $('#inpostApiNazwa').html(settings.nazwa);

        $('#inpostApiError').fadeOut('slow', function(){
            $(this).remove();
        });
    }

/**************************************************************************************************/
    function checkSelectedDocuments(){
        if ( docSelection.selected.length == 0 ){
            print_message('Naley wybra dokumenty');
            return false;
        }

        return true;
    }

    function pickupCall() {
        if ( !checkSelectedDocuments() ) {
            return false;
        }

        var $form  = $(this);
        docSelection.appendTo(this, {'assoc' : true, 'field' : 'packageNo'});

        //this.submit(); return true;
        var $status = $form.find('select[name=zk_status]');
        var status_id = $status.val(), status = null;
        if ( status_id ) {
            status = $status[0].options[$status[0].selectedIndex].text;
        }

        showLoading();
        $pickupDialog.dialog('disable');
        $activeDialog = $pickupDialog;

        $form.ajaxSubmit($.extend({}, settingsAjax, {
            'dataType':  'json',
            'success': function(data){
                hideLoading();
                $pickupDialog.dialog( "enable" );

                print_message( data );

                if ( !data.error ) {
                    //jeszcze zostanie aktualizacja numeru dokumentu wydania przy zamwieniach
                    if ( data.object ) {
                        var doc_id, $doc_row, doc, i;

                        for ( i = 0; i < data.object.zamowienia.length; i++ ) {
                            doc_id = data.object.zamowienia[i];
                            $doc_row = $('#doc' + doc_id + '_row');

                            if ( $doc_row.length ) {
                                doc = $doc_row.metadata(metadataOptions);
                                if( doc ) {
                                    doc.dokument = data.object.dokument;
                                    $doc_row.attr('data', JSON.stringify(doc));
                                }
                            }

                            if ( status ) {
                                $doc_row.find('.zk-status').html( status );
                            }
                        }
                    }

                    $pickupDialog.dialog("close");
                    $activeDialog = null;
                }
            }
        }));

        return false;
    }


    function pickupDialogOpen( e ){
        e.preventDefault();

        if ( !$pickupDialog ) {
            $pickupDialog = $('#inpostPickupDialog').dialog( $.extend({},dialogOptions, {
                'title' : 'Zamawianie kuriera dla przesyek',
                'width': 730,
                'buttons' : [
                    {
                        'text': "Anuluj",
                        'icons' : {'primary' : 'ui-icon-cancel'},
                        'click': function() {$(this).dialog("close");}
                    },
                    {
                        'text': "Zapisz",
                        'icons' : {primary : 'ui-icon-disk'},
                        'click': function() {$(this).find("form").submit();}
                    }
                ]
            }));

            $pickupDialog.find('input[type=submit]').hide();
            $pickupDialog.find('form').submit(pickupCall);
        }

        $pickupDialog.find('.dokumenty').html('<h3>Wybrane dokumenty</h3>');
        var selected = [];
        if ( docSelection.selected.length > 0 ) {
            var warning, warnings = false, r = null;

            var $ul = $('<ol class="lista"></ol>');
            for ( r in docSelection.records ){
                warning = '';
                if ( !docSelection.records[r].packageNo || docSelection.records[r].packageNo == '' ) {
                    warning = 'Uwaga! Dla tego dokumentu nie zosta jeszcze przygotowana przesyka';
                } else if ( docSelection.records[r].pickupNo ){
                    warning = 'Uwaga! Dla tego dokumentu zosta ju zamwiony kurier o numerze ' + docSelection.records[r].pickupNo;
                } else {
                    selected.push(docSelection.records[r].packageNo);
                }

                $ul.append( '<li class="rekord" >' + docSelection.records[r].numer + ( warning ? ' <span class="warning" title="'+warning+'" style="float: none; vertical-align:middle">&nbsp;</span>' : '') + '</li>' );

                if ( warning ) warnings = true;
            }

            if ( !selected.length ){
                checkSelectedDocuments();
                return false;
            }

            $pickupDialog.find('.dokumenty').append($ul);

            $ul.find('.warning').tooltip().button({
                'icons' : {
                    'primary' : 'ui-icon-alert'
                },
                'text' : false
            });

            if ( warnings ) {
                print_message('Uwaga cz wybranych dokumentw nie moe zosta wykorzystana do zamwienia kuriera. Sprawd ostrzeenia wywietlane przy numerze dokumentu. Dokumenty przy ktrych s ostrzeenia nie zostan wzite podczas zamawiania kuriera.');
            }
        } else {
            checkSelectedDocuments();
            return false;
        }

        //wysyam zamowione i po odebraniu danych ustawiam w formularzu
        $.ajax($.extend({},settingsAjax, {
            'url' : Inpost.url,
            'type' : 'POST',
            'dataType': 'json',
            'data': {
                'mode': 'pickup',
                'selected': selected
            },
            'async' : false,
            'beforeSend': function(){
                showLoading();
            },
            'complete': function(){
                hideLoading();
            },
            'success' : function ( data ) {
                hideLoading();

                console.log(data);

                $pickupDialog.dialog('open');
            }
        }));

        return false;
    }

/**************************************************************************************************/

    function availableServicesRefresh(){
        var $form  = $(this).closest('form');

        $form.ajaxSubmit($.extend({},settingsAjax, {
            dataType:  'json',
            data: {
                mode: 'available_services'
            },
            beforeSend: function(){
                showLoading();
            },
            success: function(data){
                var $select = $form.find('select[name=ServiceId]');

                //print_message( data );
                if ( data && !data.error && data.object ) {
                    try{
                        var services = data.object.AvailableServices.Service;

                        if ( services.length > 0 ) {
                            var o, s, found;
                            var refreshOptions = false;
                            for(  s = 0; s < services.length; s++ ) {
                                found = false;
                                for( o = 0; o < $select[0].options.length; o++ ){
                                    if ( $select[0].options[o].value == services[s].ID ) {
                                        found = true;
                                        break;
                                    }
                                }

                                if ( !found ) {
                                    refreshOptions = true;
                                }
                            }

                            if ( refreshOptions ) {
                                var serviceId = $select.val();
                                $select.children('option:gt(0)').remove();

                                for ( s = 0; i < services.length ; s++ ) {
                                    $select.append('<option value="' + services[s].ID + '" '+(serviceId == services[s].ID ? 'selected=selected' : '')+'>' + services[s].Name + '</option>');
                                }
                            }

                        }

                    }catch( e ){
                        console.log(e)
                    }
                }
            },
            complete: function(){
                hideLoading();
            }
        }));

        return false;
    }


/**************************************************************************************************/
    function parcelDialogOpen( e ){
        if ( e && e.preventDefault && typeof(e.preventDefault) == 'function' ) {
            e.preventDefault();
        }

        var $this = $(this);
        if ( !$parcelDialog ) {
            $parcelDialog = $('#inpostParcelDialog').dialog( $.extend({},dialogOptions, {
                'title' : 'Dodawanie/Edycja paczek',
                'width' : 660,
                'stack' : true,
                'open' : function(){
                    validatorClearForm($('form',this));
                },
                'buttons' : [
                    {
                        'text': "Anuluj",
                        'icons' : {'primary' : 'ui-icon-cancel'},
                        'click': function() {$(this).dialog("close");}
                    },
                    {
                        'text': "Zapisz",
                        'icons' : {primary : 'ui-icon-disk'},
                        'click': function() {$(this).find("form").submit();}
                    }
                ]
            }));

            $parcelDialog.find('input[type=submit]').hide();

            //$parcelDialog.find('form').submit(parcelSave);
            $parcelDialog.find('form').validate({
                submitHandler: parcelSave
            });
        }

        var paczka = {
            'Type' : '',
            'Weight' : '',
            'D' : 0,
            'S' : 0,
            'W' : 0,
            'IsNST': false
        };

        if ( Inpost.parcelIndex >= 0 && Inpost.parcels && Inpost.parcels.length >0 && Inpost.parcelIndex < Inpost.parcels.length ) {
            paczka = Inpost.parcels[Inpost.parcelIndex];
        }

        //ustawiam wartosci w formularzu
        var $input = null;
        if ( paczka ) {
            for ( var a in paczka ) {
                $input = $parcelDialog.find('input[name=' + a + ']');
                if ( $input.length ) {
                    if ( $input[0].type == 'checkbox' ) {
                        $input[0].checked = paczka[a] ? true : false;
                    } else {
                        $input.val(paczka[a]);
                    }
                }
            }
        }

        $parcelDialog.dialog('open');
    }

    function parcelSave( form, e ) {
        if( e && e.preventDefault && typeof(e.preventDefault) == 'function' ) {
            e.preventDefault();
        }

        var $form  = $(form);

        var paczka = formGetValues($form[0]);

        if ( !paczka.Type ) {
            alert('Wybierz typ paczki!');
            return false;
        }

        if ( !paczka.Weight ) {
            alert('Wpisz wag paczki!');
            return false;
        }

        if ( !Inpost.parcels || !Inpost.parcels.length || typeof(Inpost.parcels.length) == 'undefined' ) {
            Inpost.parcels = [];
        }

        if ( Inpost.parcelIndex >= 0 && Inpost.parcelIndex < Inpost.parcels.length ) {
            Inpost.parcels[Inpost.parcelIndex] = paczka;
        } else {
            Inpost.parcels.push(paczka);
        }

        //wypisuje parcels
        inpostParcelsPrint();

        //zamykam okno dialogowe parcels
        $parcelDialog.dialog('close');

        return false;
    }

    function inpostParcelAdd(){
        Inpost.parcelIndex = -1;

        parcelDialogOpen();
    }

    function inpostParcelEdit ( e ) {
        if ( e && e.preventDefault && typeof(e.preventDefault) == 'function' ) {
            e.preventDefault();
        }

        var $tr = $(this).parents('tr');
        Inpost.parcelIndex = $tr.index() - 1;
        parcelDialogOpen();

        return false;
    }

    function inpostParcelDelete ( e ) {
        if ( e && e.preventDefault && typeof(e.preventDefault) == 'function' ) {
            e.preventDefault();
        }

        if ( confirm('Jeste pewien, e chcesz usun paczk?') ) {
            var $tr = $(this).parents('tr');
            var i = $tr.index() - 1;

            Inpost.parcels.splice( i, 1);

            inpostParcelsPrint();
        }

        return false;
    }


    function inpostParcelsPrint( ) {

        var $parcels_inputs = $('#inpostShipmentParcelsInputs');
        if ( !$inpostPaczki ){
            $inpostPaczki = $('#inpostShipmentParcels');
        }

        var rows = $inpostPaczki.find('tr');
        for ( var i = 1; i < rows.length; i++ ) {
            $(rows[i]).remove();
        }

        //czyszce dane dotyczace paczek
        $parcels_inputs.html('');

        if ( Inpost.parcels ) {
            var paczka, f;

            for ( var i = 0; i < Inpost.parcels.length; i++ ){
                paczka = Inpost.parcels[i];
                $inpostPaczki.append( inpostParcelPrint(paczka, i+1) );

                for( f in paczka ) {
                    $parcels_inputs.append('<input type=hidden name="Parcels['+i+']['+f+']" value="'+paczka[f]+'" />');
                }
            }
        }
    }

    function inpostParcelPrint ( paczka, lp ) {
        var $row = $('<tr>');
        if ( lp % 2 == 1 ) {
            //$row.addClass('odd');
        }

        var $a_del   = $('<a>').html('&amp;').attr('href', '#').button({
            'text': false,
            'icons' : {
                'primary' : 'ui-icon-trash'
            }
        }).click(inpostParcelDelete);

        var $a_edit   = $('<a>').html('&amp;').attr('href', '#').button({
            'text': false,
            'icons' : {
                'primary' : 'ui-icon-pencil'
            }
        }).click(inpostParcelEdit);

        var $td = $('<td>');
        $row.append($td.clone().html( lp + '.&nbsp;&nbsp;' ).attr('align', 'right'));

        $row.append($td.clone().html( Inpost.parcelTypes && Inpost.parcelTypes[paczka.Type] ? Inpost.parcelTypes[paczka.Type] : 'Inna' ).attr('align', 'left') );
        $row.append($td.clone().html( paczka.Weight + '&nbsp;kg' ).attr('align', 'right') );
        $row.append($td.clone().html( intval(paczka.D) + '&nbsp;cm' ).attr('align', 'right') );
        $row.append($td.clone().html( intval(paczka.S) + '&nbsp;cm' ).attr('align', 'right') );
        $row.append($td.clone().html( intval(paczka.W) + '&nbsp;cm' ).attr('align', 'right') );

        $row.append($td.attr('align', 'center').append( $a_edit ).append($a_del) );

        return $row;
    }

/**************************************************************************************************/
    function templateOptions() {
        var $select = null;
        if ( arguments.length ) {
            $select = arguments[0];
        } else {
            $select  = $shipmentDialog.find('select[name=tpl]');
        }
        var i, o, update = false;

        if ( !Inpost.template_options ) {
            Inpost.template_options = [];
        }

        if ( Inpost.templates ) {
            Inpost.template_options = [];

            for ( o in Inpost.templates ) {
                if( typeof(Inpost.templates[o]) == 'object' ){
                    Inpost.template_options.push(o) ;
                }
            }
        }

        var options = [];
        for ( o = 0; o < $select[0].options.length; o++ ) {
            options.push($select[0].options[0].value);
        }

        if( options.length == Inpost.template_options.length ) {
            for( i = 0; i < Inpost.template_options.length; i++ ) {
                if ( options.indexOf(Inpost.template_options[i]) == -1 ) {
                    update = true;
                    break;
                }
            }
        } else {
            update = true;
        }


        if ( update ) {
            //zapamietuje ostatnia wartosc w selekcie przed aktualizacja
            var val = $select.val();

            $select.children('option:gt(0)').remove();

            Inpost.template_options.sort();
            for ( var i = 0; i < Inpost.template_options.length ; i++ ) {
                $select.append('<option value="' + Inpost.template_options[i]+ '" '+(val == Inpost.template_options[i]? 'selected=selected' : '')+'>' + Inpost.template_options[i] + '</option>');
            }
        }
    }

    function templateDelete( ){
        var tpl = $shipmentDialog.find('select[name=tpl]').val();

        if ( !tpl ) {
            print_message( 'Wybierz szablon przesyki ktry chcesz usun' );
            return false;
        }

        $.ajax($.extend({},settingsAjax, {
            'url': Inpost.url,
            'dataType':  'json',
            'data':  {'mode' : 'template', 'delete' : tpl},

            'success': function(data) {
                hideLoading();
                $shipmentDialog.dialog( "enable" );

                print_message( data );

                if ( !data.error && tpl && Inpost.templates[tpl] ) {
                    delete Inpost.templates[tpl];
                    Inpost.template_options = [];
                    templateOptions();
                }
            }
        }));

        return false;
    }

    function shipmentDeliveryHourChange(){
        //console.log('shipmentDeliveryHourChange()');

        var $check = $('#inpostShipmentRDH');
        if( $check.length ) {
            if ( this.value ) {
                if ( !$check[0].checked ) {
                    $check[0].checked = true;
                    $check.triggerHandler('click');
                }
            } else if( $check[0].checked ) {
                $check[0].checked = false;
                $check.triggerHandler('click');
            }
        }
    }

    function shipmentRDHClick(){
        //console.log('shipmentRDHClick');

        var $input = $( '#inpostShipmentDeliveryHour');
        if ( $input.length ) {
            if( this.checked ) {
                if( !$input.hasClass('required') ){
                    $input[0].className = 'required' + ($input[0].className ? ' ' + $input[0].className : '');
                }
            } else {
                //czyszcze wartosc
                $input.val('');
                $input.removeClass('required');
            }
        }
    }

    function serviceIdOnChange(){
        var $opt =  $('#inpostShipmentRDHRow');

        var label = this.options && this.options[this.selectedIndex] ? this.options[this.selectedIndex].label : '';
        var hour_match = label ? label.match(/[0-9][0-9]:00/) : null;

        console.log('shipmentServiceIdChange: ' + label);
        if( hour_match ) {
            var $select = $('#inpostShipmentDeliveryHour');
            var val = $select.val();

            var hours = [];
            if ( hour_match[0] == '10:00' ) {
                hours = ['', '08:00', '09:00'];
            } else if ( hour_match[0] == '12:00' ) {
                hours = ['', '10:00', '11:00'];
            }else if ( hour_match[0] == '17:00' ) {
                hours = ['', '12:00', '13:00', '14:00', '15:00', '16:00'];
            }

            $select.children('option').remove();
            for ( var i = 0; i < hours.length ; i++ ) {
                $select.append('<option value="' + hours[i]+ '" '+(val == hours[i]? 'selected=selected' : '')+'>' + hours[i] + '</option>');
            }

            //wysuwam
            $opt.slideDown();
        } else {
            $opt.slideUp();
        }
    }

    function shipmentTriggerHandlers() {
        $('#inpostShipmentServiceId').triggerHandler('change');

        $('#inpostShipmentDeliveryHour').triggerHandler('change');
        $('#inpostShipmentRDH').triggerHandler('click');

        $('#inpostShipmentInsurance').triggerHandler('click');
        $('#inpostShipmentInsuranceAmountAuto').triggerHandler('click');

        $('#inpostShipmentCOD').triggerHandler('click');
        $('#inpostShipmentCODAuto').triggerHandler('click');

        $('#inpostShipmentInsuranceAmount').triggerHandler('blur');
        $('#inpostShipmentCODAmount').triggerHandler('blur');
    }

    var templateChangeBusyState = false;
    function templateOnChange( e ){
        if ( templateChangeBusyState ){
            return;
        }
        console.log('templateOnChange: ' + this.value );
        templateChangeBusyState = true;

        var data = {}, val = this.value, options = $shipmentDialog.data('options');
        var doc = shipmentGetDocument();

        if ( doc && (doc.id || doc.ID) ) {
            if( doc && doc.shipment && !val ) {
                shipmentFormUpdate(doc.shipment, doc);
            } else if( doc.id ){
                shipmentDocumentData( doc.id ? doc.id: doc.ID, val );
            }
        } else {
            if ( this.value && Inpost.templates[this.value] ) {
                data = Inpost.templates[this.value];
            }

            this.value = val;

            shipmentFormUpdate(data);
        }

        templateChangeBusyState = false;

        //aktualizuje nazw
        Inpost.template = this.value;

        return true;
    }

    /**
     * Aktualizauje dane formularza z przesyk na podstawie przekazanych danych o przesyce i dokumencie
     *
     * @returns {undefined}
     */
    function shipmentFormUpdate(shipment, doc ){
        if( (doc || shipmentGetDocument()) && shipment.opcje ){
            shipment.opcje.codAuto = 0;
            shipment.opcje.insuranceAmountAuto = 0;
        }

        var $form = $shipmentDialog.find('form');
        formSetValues( $form[0], shipment, {
            'clear' : $form.find('input,select').not('[name=tpl]').not('[type=hidden]')
        });

        shipmentParseParcels(shipment);

        if ( doc ) {
            shipmentDocumentInfo(doc);
        }

        shipmentTriggerHandlers();
    }

    var shipmentDocumentDataBusyState = false;
    function shipmentDocumentData ( id, template ) {
        if ( shipmentDocumentDataBusyState ){
            return;
        }

        console.log('shipmentDocumentData('+id+', ' +template+'  )')
        if ( id > 0 && typeof(template) == 'string' && template != '' ){
            shipmentDocumentDataBusyState = true;

            $activeDialog = $shipmentDialog;
            $shipmentDialog.dialog('disable');

            $.ajax($.extend({}, settingsAjax, {
                'url': Inpost.url,
                'dataType':  'json',
                'data':  {
                    'mode' : 'shipment',
                    'id' : id,
                    'template' : template,
                    'doc_type' : $shipmentDialog.find('input[name=doc_type]').val()
                },

                'success': function(data) {
                    hideLoading();
                    $shipmentDialog.dialog( "enable" );
                    shipmentDocumentDataBusyState = false;

                    print_message( data );

                    if ( !data.error ) {
                        shipmentFormUpdate(data.object.shipment, data.object.dokument);
                    }
                }
            }));
        }
    }

    function shipmentDocumentInfo( dokument ){
        var html = '<div class="head">Informacja o dokumencie</div>';
        var doc = jQuery.extend({}, dokument ? dokument : {});

        if ( doc.PLN_WARTOSC_NETTO ) {
            doc.PLN_WARTOSC_NETTO = currency_format(doc.PLN_WARTOSC_NETTO) + ' PLN';
        }

        if ( doc.PLN_WARTOSC_BRUTTO ) {
            doc.PLN_WARTOSC_BRUTTO = currency_format(doc.PLN_WARTOSC_BRUTTO) + ' PLN';
        }

        html += '<div class="zwin-rozwin">' + print_object( '#inpostShipmentDokumentTemplate', doc ) + '</div>';
        html = html.replace('inpostShipmentDokumentTemplate', 'inpostShipmentDokumentData');

        $('#inpostShipmentDokument').html( html ).slideDown();

        var $a = $('<a href="#">Zwi</a>');
        $a.css({
            float: 'right',
            display: 'inline-block',
            'margin-right': '10px',
            color: 'white'
        }).click(function(e){
            e.preventDefault();

            var $div  = jQuery(this).parent().next('div.zwin-rozwin');
            if ( $div.length ) {
                if( $div .is(":visible") ) {
                    $div.slideUp();
                    this.innerHTML = 'Rozwi';
                } else {
                    $div.slideDown();
                    this.innerHTML = 'Zwi';
                }
            }

            return false;
        });

        $('#inpostShipmentDokument').find('div.head').append($a);
    }

    function shipmentDocumentsHTML( $dokumenty ) {
        $dokumenty.html('<div class="head">Wybrane dokumenty</div>').show();

        if ( docSelection.selected.length > 0 ) {
            var warning, warnings = false, r = null;

            var $ul = $('<ol class="lista"></ol>');
            for ( r in docSelection.records ){
                warning = '';
                if ( docSelection.records[r].packageNo && docSelection.records[r].packageNo != '' ) {
                    warning = 'Uwaga! Dla tego dokumentu zostaa ju stworzona przesyka o numerze: ' + docSelection.records[r].packageNo + ' w systemie WebMobile7';
                }

                $ul.append( '<li class="item doc-numer">' + docSelection.records[r].numer + ( warning ? ' <span class="warning" title="'+warning+'" style="float: none; vertical-align:middle">&nbsp;</span>' : '') + '</li>' );

                if ( warning ) warnings = true;
            }

            $dokumenty.append($ul);

            $ul.find('.warning').tooltip().button({
                'icons' : {
                    'primary' : 'ui-icon-alert'
                },
                'text' : false
            });

            if ( warnings ) {
                print_message('Uwaga dla czci wybranych dokumentw nie moe zosta stworzona przesylka. Dla dokumentw przy ktrych wywitlaj si ostrzeenia nie zostan utworzone przesyki. Sprawd ostrzeenia wywietlane przy numerze dokumentu');
            }
        } else {
            checkSelectedDocuments();
        }
    }

    function shipmentParseParcels(shipment){
        if ( shipment && shipment.Parcels  ) {
            if( shipment.Parcels.Parcel ) {
                if ( shipment.Parcels.Parcel.lenght && shipment.Parcels.Parcel[0] ) {
                    Inpost.parcels = shipment.Parcels.Parcel
                } else if ( shipment.Parcels.Parcel.Type && shipment.Parcels.Parcel.Weight ) {
                    Inpost.parcels = [];
                    Inpost.parcels.push(shipment.Parcels.Parcel);
                }
            } else if( shipment.Parcels.length || shipment.Parcels[0] ){
                Inpost.parcels  = shipment.Parcels;
            }else{
                Inpost.parcels = [];
            }
        } else {
            Inpost.parcels = [];
        }
        inpostParcelsPrint();
    }

    function shipmentGetDocument(){
        var options = $shipmentDialog.data('options');

        if ( options && options.dokument && options.dokument.id ) {
            var doci = options.dokument.index;
            var doc = null;

            if ( Inpost.docs[doci]   ) {
                doc =  $.extend({}, Inpost.docs[doci], options.dokument);
            } else {
                for( var i = 0 ; i < Inpost.docs.length ; i++  ) {
                    if ( Inpost.docs[i].ID == options.dokument.id ) {
                        doc =  $.extend({}, Inpost.docs[doci], options.dokument);
                    }
                }
            }

            return doc;
        }

        return null;
    }

    function shipToIsRequired(){
        if( $shipmentDialog ) {
            var opts = $shipmentDialog.data('options');

            //dla szablonu lub multiple
            if( opts && (opts.multiple || opts.template)){
                return false;
            }
        }

        return true;
    }

    function shipmentInsuranceClick(){
        //console.log('shipmentInsuranceClick');
        var $inputs = $($(this).attr('data-require'));

        if ( $inputs.length ) {
            $inputs.removeClass('required');

            if ( this.checked ) {
                for( var i = 0 ; i < $inputs.length; i++ ) {
                    $inputs[i].className = 'required' + ($inputs[i].className ? ' ' + $inputs[i].className : '');
                }

                if ( arguments[0] ) {
                    //pobieram dokument aktualnie przetwarzany dokument
                    var doc = shipmentGetDocument();

                    if ( doc && doc.PLN_WARTOSC_BRUTTO ) {
                        if ( !$inputs.val() ) {
                            $inputs.val(currency_format(doc.PLN_WARTOSC_BRUTTO));
                        }
                    }
                }
            } else {
                //czyszcze wartosc
                $inputs.val('');
            }
        }


        var opts = $shipmentDialog.data('options');
        if ( opts && (opts.template || opts.multi) ) {
            //pokazuje wiersz z auto ustawieniem kwoty dla przesyki
            if ( this.checked ) {
                $('#inpostShipmentInsuranceAmountAutoRow').slideDown();
            } else {
                $('#inpostShipmentInsuranceAmountAutoRow')[0].checked = false;
                $('#inpostShipmentInsuranceAmountAutoRow').slideUp();
            }
        }
    }


    function shipmentInsuranceAmountAutoClick(){
        //console.log('shipmentInsuranceAmountAutoClick()');
        var $inputs = $('#inpostShipmentInsuranceAmount');

        if ( $inputs.length ) {
            if ( this.checked ) {
                $inputs.removeClass('required');
            } else if ( $('#inpostShipmentInsurance')[0].checked && !$inputs.hasClass('required') ) {
                $inputs[0].className = 'required ' + $inputs[0].className;
            }
        }
    }

    function shipmentInsuranceAmountBlur(){
        if ( this.value != '' && this.value != '0' ) {
            var validator = $( this.form).validate();
            validator.element(this);

            if ( this.value && $(this).hasClass('valid') ) {
                var $check = $('#inpostShipmentInsurance');

                if ( !$check[0].checked ) {
                    $check[0].checked = true;
                    shipmentInsuranceClick.call($check[0], false);
                }
            }
        }
    }


    function shipmentCODClick(){
        //console.log('shipmentCODClick');
        var $inputs = $($(this).attr('data-require'));
        var $account = $('#inpostShipmentRetAccountNo');


        var opts = $shipmentDialog.data('options');

        if ( $account.length ) {
            if ( this.checked ) {
                if ( !$account.hasClass('required') ) {
                    $account[0].className  = 'required' + ($account[0].className ? ' ' + $account[0].className : '');
                }
            } else {
                $account.removeClass('required');
            }
        }

        if ( $inputs.length ) {
            $inputs.removeClass('required');

            if ( this.checked ) {
                //mamy dokument
                var doc = shipmentGetDocument();
                if ( doc ) {
                    for ( var i = 0 ; i < $inputs.length; i++ ) {
                        $inputs[i].className = 'required' + ($inputs[i].className ? ' ' + $inputs[i].className : '');
                    }
                }

                if( doc && doc.PLN_WARTOSC_BRUTTO ) {
                    if ( !$inputs.val() ) {
                        $inputs.val(currency_format(doc.PLN_WARTOSC_BRUTTO));
                    }
                }
            } else {
                //ksuje zawartosc
                $inputs.val('');
            }
        }

        if (opts && (opts.multi || opts.template)) {
            if ( this.checked  ) {
                $('#inpostShipmentCODAuto').parent().slideUp();
            } else {
                $('#inpostShipmentCODAuto').parent().slideDown();
            }
        }
    }

    function shipmentCODAutoClick(){
        //console.log('shipmentCODAutoClick');

        var $inputs = $('#inpostShipmentRetAccountNo');
        if ( $inputs.length ) {
            if ( this.checked ) {
                if ( !$inputs.hasClass('required') ) {
                    $inputs[0].className = 'required' + ($inputs[0].className ? ' ' + $inputs[0].className : '');
                }
            } else {
                $inputs.removeClass('required');
            }
        }


        var opts = $shipmentDialog.data('options');
        if ( opts && (opts.multi || opts.template)) {
            if ( this.checked  ) {
                $('#inpostShipmentCOD').parent().slideUp();
            } else {
                $('#inpostShipmentCOD').parent().slideDown();
            }
        }
    }

    function shipmentCODAmountBlur(){
        if ( this.value != '' && this.value != '0' ) {
            var validator = $(this.form).validate();
            validator.element(this);

            if ( $(this).hasClass('valid') && this.value ) {
                var $check = $('#inpostShipmentInsurance');

                $check[0].checked = true;
                $check.triggerHandler('click');
            }
        }
    }


    function shipmentOpen ( e ) {
        if( e && typeof(e.preventDefault) == 'function' ){
            e.preventDefault();
        }

        var options = {};
        var $this = $(this);

        options.template = this.id.indexOf('Template') > -1;
        options.multiple = this.id.indexOf('Shipments') > -1;
        options.dokument = {};

        if ( !options.multiple && !options.template ) {
            options.dokument = $this.parents('tr').metadata(metadataOptions);
            //console.log(options.dokument);
        }

        var firstRun = false;

        if ( !$shipmentDialog ) {
            firstRun = true;

            $shipmentDialog = $('#inpostShipmentDialog').dialog( $.extend({},dialogOptions, {
                'maxWidth': 1400,
                'width' : 1100,
                'open' : function(){
                    validatorClearForm($('form', this));
                }
            }));

            $shipmentDialog.find('input[type=submit]').hide();

            $shipmentDialog.find('select[name=ServiceId]').change(serviceIdOnChange);
            $shipmentDialog.find('a.refresh-btn').button({
                'icons' : {
                    'primary' : 'ui-icon-refresh'
                },
                'text' : false
            }).click(availableServicesRefresh);
            $shipmentDialog.find('select[name=tpl]').change(templateOnChange);

            $('#inpostShipmentDeliveryHour').change(shipmentDeliveryHourChange);
            $('#inpostShipmentRDH').click(shipmentRDHClick);

            $('#inpostShipmentInsurance').click(shipmentInsuranceClick);
            $('#inpostShipmentInsuranceAmount').blur(shipmentInsuranceAmountBlur);
            $('#inpostShipmentInsuranceAmountAuto').click(shipmentInsuranceAmountAutoClick);

            $('#inpostShipmentCOD').click(shipmentCODClick);
            $('#inpostShipmentCODAuto').click(shipmentCODAutoClick);
            $('#inpostShipmentCODAmount').blur(shipmentCODAmountBlur);

            //$shipmentDialog.find('form').submit(shipmentSave);
            $shipmentValidator = $shipmentDialog.find('form').validate({
                submitHandler: shipmentSave,
                rules: {
                    'ShipTo[Name]': { required: shipToIsRequired },
                    'ShipTo[PostCode]': { required: shipToIsRequired },
                    'ShipTo[City]': { required: shipToIsRequired },
                    'ShipTo[CountryCode]': { required: shipToIsRequired },
                    'ShipTo[Address]': { required: shipToIsRequired },
                    'ShipTo[Person]': { required: shipToIsRequired },
                    //'ShipTo[Contact]': { required: shipToIsRequired },
                    //'ShipTo[Email]': { required: shipToIsRequired }

                    'COD[Amount]': {
                        required: function(){
                            //console.log('COD[Amount] is required: ' + (shipmentGetDocument() && $('#inpostShipmentCOD')[0].checked ? 'true' : 'false') );
                            //wymagane jeli jest zaznaczony checkbox
                            return ((shipmentGetDocument() && $('#inpostShipmentCOD')[0].checked) ? true : false);
                        }
                    },

                    'COD[RetAccountNo]': {
                        required: function(){
                            //wymagane jeli jest zaznaczony checkbox
                            return ($('#inpostShipmentCOD')[0].checked || $('#inpostShipmentCODAuto')[0].checked );
                        }
                    },

                    'insuranceAmount': {
                        required: function(){
                            var required = true;
                            //wymagane jeli jest zaznaczony checkbox
                            if ( shipmentGetDocument() ) {
                                required = $('#inpostShipmentInsurance')[0].checked;
                            } else {
                                required = $('#inpostShipmentInsurance')[0].checked && !$('#inpostShipmentInsuranceAmountAuto')[0].checked;
                            }

                            return required;
                        }
                    }
                }
            });

            //autocomplete dla kraju
            $('#inpostShipmentShipFromCountryCode,#inpostShipmentShipToCountryCode').countryCombobox({
                'field_value': 'alpha2'
            });

            templateOptions();
        }

        //resetuje parcels
        Inpost.parcels  = [];
        inpostParcelsPrint();

/**************************************************************************************************/
        var shipmentOptions = {
            'title' : ( options.dokument.packageNo ? 'Szczegy przesyki o numerze: '  + options.dokument.packageNo : this.title),
            'close' : function(){

            }
        };

        shipmentOptions.buttons = [];
        shipmentOptions.buttons = [
            {
                'text': options.dokument.packageNo ? "Zamknij" : "Anuluj",
                'icons' : {'primary' : 'ui-icon-cancel'},
                'click': function() {$(this).dialog("close");}
            }
        ];

        //jesli wyswietlamy szczegy przesyki
        if ( !options.dokument.packageNo ) {
            shipmentOptions.buttons.push({
                'text': "Paczka",
                'icons' : {'primary' : 'ui-icon-plus'},
                'click': inpostParcelAdd
            });
        }

        if ( options.template ) {
            shipmentOptions.buttons.push({
                'text': "Usu",
                'icons': {primary : 'ui-icon-trash'},
                'click': templateDelete
            });

            shipmentOptions.buttons.push({
                'text': "Zapisz",
                'icons' : {primary : 'ui-icon-disk'},
                'click': function() {$(this).find("form").submit();}
            });
        } else if ( options.dokument.packageNo ){
            shipmentOptions.buttons.push({
                'text': "Anuluj przesyk",
                'icons' : {primary : 'ui-icon-cancel'},
                'click': shipmentCancel
            });
        }else{
            shipmentOptions.buttons.push({
                'text': "Ok",
                'icons' : {primary : 'ui-icon-disk'},
                'click': function() {$(this).find("form").submit();}
            });
        }

        //ustawiam opcje
        $shipmentDialog.data('options', options);

/**************************************************************************************************/
        var $form = $shipmentDialog.find('form');

        if ( options.dokument && options.dokument.id ) {
            var doci = options.dokument.index;
            var doc = Inpost.docs[doci];

            //jesli juz mamy przesyk
            if ( options.dokument.packageNo ) {
                //console.log(doc.shipment);
                shipmentFormUpdate(doc.shipment, doc);

                if ( doc.shipment.tpl && !tpl ) {
                    tpl = $form.find('[name=template]')[0].value = doc.shipment.tpl;
                }

                shipmentOptions.close = function(){
                    $shipmentDialog.find('[name=template]').hide();
                    $shipmentDialog.find('[name=tpl]').show();
                    var $fields = $shipmentDialog.find('input,select,textarea').not('[type=hidden]').not('[name=PackageNo]');
                    $fields.each(function(){
                        this.readonly = false;
                        this.disabled = false;
                    }).removeClass('disabled');
                };

                print_message('Sprawd dane przesyki o numerze: ' +options.dokument.packageNo+ ' dla dokumentu ' + doc.NUMER);
            }else if ( doc && doc.shipment ) {
                var tpl = $('#inpostShipmentTemplate').val();

                if ( tpl /*&& (doc.shipment.tpl != tpl)*/ ) {
                    shipmentDocumentData(options.dokument.id, tpl );
                } else {
                    //console.log(doc.shipment);
                    shipmentFormUpdate(doc.shipment, doc);

                    if ( doc.shipment.tpl && !tpl ) {
                        tpl = $form.find('[name=tpl]')[0].value = doc.shipment.tpl;
                    }

                    if ( tpl ) {
                        print_message('Sprawd dane przesyki dla dokumentu ' + doc.NUMER);
                    }else{
                        print_message('Wybierz szablon przesyki aby utworzy przesyk wedug zapsanego schematu, albo wypenij samodzielnie dane do przesyki.');
                    }
                }
            }
        } else {
            $('#inpostShipmentDokument').hide().html('');
            $('#inpostShipmentTemplate').triggerHandler('change');

            var $tpl = $shipmentDialog.find('select[name=tpl]');
            if ( Inpost.template != $tpl.val() ) {
                $tpl.val(Inpost.template).triggerHandler('change');
            }
        }

        //ustawiam opcje do dialogbox'a
        $shipmentDialog.dialog('option', shipmentOptions );

        //jesli tworzenie szablonu, pierwsze otworzenie i nie ma ju zdefiniowanych szablonw to ustaw dane domyslne
        if ( firstRun && options.template && (!Inpost.template_options || Inpost.template_options.length == 0) ) {
            if ( Inpost.defaultShipment ) {
                shipmentFormUpdate(Inpost.defaultShipment);
            }
        }

        if ( options.multiple || options.template ){
            $shipmentDialog.find('.template0').hide();
            $shipmentDialog.find('.template1').show();

            if ( options.multiple ){
                $shipmentDialog.find('.multi0').hide();
            } else {
                $shipmentDialog.find('.multi0').show();
            }

        } else {
            $shipmentDialog.find('.template0, .multi0').show();
            $shipmentDialog.find('.template1, .multi1').hide();
            $('#inpostShipmentTemplate').hide();
        }

        /**
         * Dla danych przesyki
         *
         */
        if ( options.dokument.packageNo ) {
            $shipmentDialog.find('[name=template]').show();
            $shipmentDialog.find('[name=tpl]').hide();

            var $fields = $shipmentDialog.find('input,select,textarea').not('[type=hidden]').not('[name=PackageNo]');

            $fields.each(function(){
                this.readonly = true;
                this.disabled = true;
            }).addClass('disabled');
        }

        var $documents = $shipmentDialog.find('.documents');
        if ( options.multiple ) {
            shipmentDocumentsHTML($documents);
        } else {
            $documents.html('').hide();
        }

        $shipmentDialog.dialog('open');
        shipmentTriggerHandlers();

        return false;
    }

    function num_pad2( n ) {
        return ( n < 10 ) ? '0' + n : n;
    }

    /**
     * Funkcja suy do sprawdzenia formualrza czy przypadkiem nie ma jakis z wybranych dokumetw dla ktrych zostaa
     * ju stworzona przesyka
     *
     * @param {type} form
     * @returns {Boolean}
     */
    function shipmentCheckSelectedDocs( form ) {
        if ( !checkSelectedDocuments() ) {
            return false;
        }

        var r, items = [];
        for ( r in docSelection.records ){
            if ( !docSelection.records[r].packageNo || docSelection.records[r].packageNo == '' ) {
                items.push( r );
            }
        }

        if ( items.length == 0 ) {
            print_message('Nie mona wysa formularza poniewa dla wybranych dokumentw przesyki zostay ju utworzone');
            return false;
        }

        docSelection.appendTo(form, {'selected' : items} );

        return true;
    }

    function shipmentSave() {
        var options = $shipmentDialog.data('options');
        var $form  =  $shipmentDialog.find('form');
        var $mode = $( 'input[name=mode]', $form );

        if ( options && options.template ){
            $mode.val( 'template' );
        } else if ( options && options.dokument && options.dokument.id ){
            $mode.val( 'shipment' );
        } else {
            $mode.val( 'shipments' );
        }

        //console.log('mode: ' + $mode.val());
        if ( options && options.multiple ){
            if ( !shipmentCheckSelectedDocs($form) ) {
                return false;
            }
        } else if ( options && options.dokument ){
           $form.find('input[name^=selected]').remove();
           $form.append('<input type="hidden" name="selected[]" value="' + options.dokument.id + '" />');
        }

        //pobieram status zamwienia
        var $status = $('#inpostShipmentOpcjeZamowienieStatus');
        var status_id = $status.val(), status = null;
        if ( status_id ) {
            status = $status[0].options[$status[0].selectedIndex].text;
        }

        //console.log('zk status: ' + status);
/**************************************************************************************************/
        //pobieram usugi aby uzupeni wartosci od brakujace dane nawet jesli chceckbox nie jest zaznaczony
        var uslugi = {};
        var some_data = $form.find("input[type=checkbox]").map(function(){
            return {'name': $(this).attr('name'), 'value': (( this.type && this.type == 'checkbox' ) ? (this.checked ? this.value : '0') : $(this).val())};
        }).get();

        for ( var i = 0; i < some_data.length; i++  ) {
            if ( some_data[i].name ) {
                uslugi[some_data[i].name] = some_data[i].value;
            }
        }
        uslugi = object_deflatte( uslugi );

        //console.log('uslugi');console.log(uslugi);

/**************************************************************************************************/

        $form.ajaxSubmit($.extend({},settingsAjax, {
            dataType:  'json',
            data: uslugi,
            beforeSend: function(){
                showLoading();
                $shipmentDialog.dialog('disable');
                $activeDialog = $shipmentDialog;
            },
            complete: function(){
                hideLoading();
                $shipmentDialog.dialog( "enable" );
            },
            success: function(data){
                if ( options && options.template ){
                    print_message( data );

                    if ( !data.error ) {
                        //jeszcze zostanie aktualizacja numeru przesylkau wydania przy zamwieniach
                        var template = data.object;
                        if ( !Inpost.templates ){
                            Inpost.templates = new Object();
                        }
                        Inpost.templates[template.template] = template;

                        //aktualizuje opcje dla template
                        templateOptions();

                        $shipmentDialog.dialog("close");
                        $activeDialog = null;
                    } else {
                        try{
                            $shipmentValidator.showErrors(data.object);
                        }catch(e){
                            console.log(e);
                        }
                    }
                } else {
                    print_message( data.message );

                    if ( data.object && data.object.length && data.object[0] ) {
                        var $doc_row, doc, dockument = null;
                        for( var i = 0; i < data.object.length; i++ ){
                            dockument = data.object[i];

                            if ( dockument.shipment ) {
                                $doc_row = $('#doc' + dockument.ID + '_row');

                                if ( $doc_row.length ) {
                                    doc = $doc_row.metadata(metadataOptions);
                                    doc.packageNo = dockument.shipment.PackageNo;
                                    doc.kurier = Inpost.kurier;
                                    $doc_row.attr('data', JSON.stringify(doc));
                                }
                                $doc_row.find('.shipment-btn').remove();
                                $doc_row.find('.wydruk-btn, .etykieta-btn, .status-btn').show()
                                $doc_row.find('.wydruk-btn, .etykieta-btn').each(function(){
                                    //dodaje numer przesyki bo nie ma w linkach
                                    this.href +=  dockument.shipment.PackageNo;
                                });

                                $doc_row.find('.packageNo').html( dockument.shipment.PackageNo );

                                if ( status ) {
                                    $doc_row.find('.zk-status').html( status );
                                }
                            } else {
                                //jesli nie ma przesyki to moge wyswietlic info
                                if ( dockument.error ) {
                                    print_message( dockument.error )
                                } else {
                                    print_message( 'Dla dokumentu: '+ dockument.NUMER +' nie udao si wygenerowa przesyki, kliknij na numer dokumentu, aby poprawi i zapisa przesyk.' );
                                }
                            }
                        }
                    }

                    if ( !data.error ) {
                        //jeszcze zostanie aktualizacja numeru przesylkau wydania przy zamwieniach
                        $shipmentDialog.dialog("close");
                        $activeDialog = null;
                    } else if ( data.object && $mode.val() == 'shipment' ) {
                        try{
                            $shipmentValidator.showErrors(data.object);
                        }catch(e){
                            console.log(e);
                        }
                    } else if( $mode.val() == 'shipments' ){
                        //aktualizacja

                    }
                }
            }
        }));

        return false;
    }

    function shipmentCancel( ){
        var doc = shipmentGetDocument()

        if ( !doc ) {
            print_message( 'Nie mona anulowa przesyki, bo brak dokumentu.' );
            return false;
        }

        if ( !doc.shipment ) {
            print_message( 'Nie mona anulowa przesyki poniewa dla dokumentu: '+doc.NUMER+' nie utworzono jeszcze przesyki.' );
            return false;
        }

        if ( !doc.packageNo ) {
            print_message( 'Nie mona anulowa przesyki poniewa dla dokumentu: '+doc.NUMER+' nie ustalono numeru przesyki.' );
            return false;
        }

        $.ajax($.extend({},settingsAjax, {
            'url': Inpost.url,
            'dataType':  'json',
            'data':  {
                'mode' : 'cancel',
                'packageNo' : doc.packageNo
            },
            'beforeSend': function(){
                showLoading();
                $shipmentDialog.dialog( "disable" );
            },
            'complete' : function(){
                hideLoading();
                $shipmentDialog.dialog( "enable" );
            },
            'success': function(data) {
                print_message( data );

                if ( !data.error && tpl && Inpost.templates[tpl] ) {
                    delete Inpost.templates[tpl];
                    Inpost.template_options = [];
                    templateOptions();
                }
            }
        }));

        return false;
    }

/**************************************************************************************************/
    function inpostCheckKurier(e){
        var $tr = $(this).parents('tr');
        var doc = $tr.metadata(metadataOptions);

        if ( !doc.packageNo || doc.packageNo == '' ){
            if ( e && typeof(e.preventDefault) == 'function' ) {
                e.preventDefault();
            }
            print_message('Dla dokumentu ' + doc.numer + ' nie mona pobra wydrukw przesyki, poniewa nie zostaa wygenrowana przesyka.');
            return false;
        }else if( doc.kurier && doc.kurier != Inpost.kurier ){
            if ( e && typeof(e.preventDefault) == 'function' ) {
                e.preventDefault();
            }

            print_message('Dla dokumentu ' + doc.numer + ' nie mona pobra wydrukw, poniewa przesyka o numerze: '+doc.packageNo+' zostaa wygenrowana u kuriera: '+doc.kurier+'.');
            return false;
        }
    }

    function setupTable( target ){
        $('.shipment-btn', target).button({
            'icons' : {
                'primary' : 'ui-icon-transfer-e-w'
            },
            'text' : false
        }).click(shipmentOpen);

        $('.wydruk-btn', target).button({
            'icons' : {
                'primary' : 'ui-icon-print'
            },
            'text' : false
        }).click(inpostCheckKurier);

        $('.etykieta-btn', target).button({
            'icons' : {
                'primary' : 'ui-icon-tag'
            },
            'text' : false
        }).click(inpostCheckKurier);

        $('.status-btn', target).button({
            'icons' : {
                'primary' : 'ui-icon-info'
            },
            'text' : false
        }).click( function(e){
            e.preventDefault();
            var $tr = $(this).parents('tr');
            var doc = $tr.metadata(metadataOptions);
            if ( !doc.packageNo || doc.packageNo == '' ){
                print_message('Dla dokumentu ' + doc.numer + ' nie mona sprawdzi statusu przesyki, poniewa nie zostaa wygenrowana przesyka.');
                return false;
            }else if( doc.kurier && doc.kurier != Inpost.kurier ){
                print_message('Dla dokumentu ' + doc.numer + ' nie mona sprawdzi statusu przesyki, poniewa przesyka o numerze: '+doc.packageNo+' zostaa wygenrowana u innego kuriera.');
                return false;
            }

            $dialog.dialog( 'option', {
                'title': 'Status przesyki dla dokumentu: ' + doc.numer,
                'width': 650,
                'buttons': [
                    {
                        'text': "Zamknij",
                        'click': function() {$(this).dialog("close");}
                    },
                    {
                        'text': "Manifest",
                        'click': function() {
                            //$(this).dialog("close");
                            window.location = Inpost.url + '&mode=manifest&packageNo=' + doc.packageNo;
                        }
                    },
                    {
                        'text': "Dane przesyki",
                        'click': function() {
                            $(this).dialog("close");
                            $tr.find('.packageNo').click();
                        }
                    }
                ]

            });

            $.ajax($.extend({},settingsAjax, {
                'url' : this.href,
                'dataType': 'html',
                'data': {
                    'packageNo': doc.packageNo
                },
                'async' : false,
                'success' : function ( data ) {
                    var obj = str2obj(data);
                    if ( obj ) {
                        print_message(obj);
                    } else {
                        $dialog.html(data);
                        $dialog.dialog('open');
                    }
                }
            }));

            return false;
        });

        $('.packageNo', target).click(function(e){
            var $this = $(this);
            var doc = $this.parents('tr').metadata(metadataOptions);

            if ( doc && doc.packageNo ) {
                var doci = doc.index;
                if ( !Inpost.docs[doci]   ) {
                    print_message('Nie mona wywietli szczegw przesyki, poniewa brak dokumentu.');
                    return false;
                }

                if ( Inpost.docs[doci].shipment   ) {
                    shipmentOpen.call(this);
                } else {
                    print_message('Dokument nie zawiera danych o wygenerowanej przesyce.');
                }
            }

            return false;
        });

        $('.dokument-btn', target).button({
            'icons' : {
                'primary' : 'ui-icon-document'
            },
            'text' : false
        }).click( function(e){
            try{}catch(e){}

            var href = this.href;
            var doc = $(this).parents('tr').metadata(metadataOptions);
            if ( !doc ) doc = {};

            if ( !doc.packageNo || doc.packageNo == '' ) {
                e.preventDefault();
                print_message('Dla dokumentu: ' + doc.numer + ' nie mona pobra dokumentu wydania poniewa nie zosta jeszcze wygenerowany numer listu przewozowego');
                return false;
            }

            if ( !doc.dokument || doc.dokument == '' ) {
                e.preventDefault();

                confirmDialog ( 'Dla dokumentu ' + doc.numer + ' nie jest przypisany numer dokumentu wydania, ale moesz sprawdzi czy list przewozowy o numerze ' + doc.packageNo + ' znajduje si ju na jakim dokumencie wydania?', {
                    'confirm' : function(){
                        window.location = href;
                    }
                });

                return false;
            }

            return true;
        });
    }

    $(function(){
        $dialog = $('#inpostDialog').dialog(dialogOptions);

        docSelection = new EcSelection('inpostContent', {
            'target' : 'docsList',
            'setup' : setupTable,
            'metadata' : metadataOptions
        });

        $('#inpostApiConfigBtn').button({
            'icons' : {
                'primary' : 'ui-icon-gear'
            },
            'text' : false
        }).click(settingsOpen);


        $('#inpostCreateShipments').click(shipmentOpen);
        $('#inpostShipmentTemplateBtn').click(shipmentOpen);
        $('#inpostCallPickup').click(pickupDialogOpen);


        $('#inpostDrukujPrzesylki,#inpostEtykietyPrzesylki').click(function(e){
            e.preventDefault();

            if ( !checkSelectedDocuments() ) return false;

            var selected = [], not_inpost = [];
            for ( var a in docSelection.records ) {
                if ( docSelection.records[a].packageNo ) {
                    if ( docSelection.records[a].kurier && docSelection.records[a].kurier != Inpost.kurier ) {
                        not_inpost.push(docSelection.records[a].packageNo);
                    } else {
                        selected.push(docSelection.records[a].packageNo);
                    }
                }
            }

            if ( selected.length  == 0 ) {
                print_message('Dla wybranych dokumentw nie zostay jeszcze utworzone przesyki i nie mona wydrukowa etykiet dla przesyek. ' + (not_inpost.length ? 'Cz przesyek dla dokumentw zostala utworzona dla innego kuriera.' : ''));
                return false;
            }

            var $form = $('#inpostForm');
            $form.attr('action', this.href);
            $form.find('input[name^=selected]').remove();
            for ( var i = 0 ; i < selected.length ; i++ ) {
                $form.append('<input type="hidden" name="selected[' + i  + ']" value="' + selected[i] + '" />');
            }
            $form[0].submit();

            return false;
        });

        $('.template').hide();
        $('.placeholder').textPlaceholder();
        $('a[title].help').tooltip();
        $('a[rel].help').click(function(e){
            $( this.rel.substr(0,1) == '#' ? this.rel : '#' + this.rel ).slideToggle('slow');
            return false;
        });
    });
})();



