/**************************************************************************************************/

function Pliki( settings ){

    if( settings['prefix'] ){
        this.prefix = settings['prefix'];
    }else{
        this.prefix = new String("");
    }

    this.max = 5;
    if( settings['max'] > 0 ){
        this.max = settings['max'];
    }

    this.szerokosc = 80;
    if( settings['szerokosc'] > 0 ){
        this.szerokosc = settings['szerokosc'];
    }

    this.wysokosc = 80;
    if( settings['wysokosc'] > 0 ){
        this.wysokosc = settings['wysokosc'];
    }

    this.simple = !empty(settings['simple']);

    if( this.prefix && this.prefix.substring( this.prefix.length - 1 ) != "_" ){
        this.prefix += '_';
    }

    if( !settings.var_name ){
        settings.var_name = 'o_' + this.prefix + 'pliki';
    }
    this.var_name = settings['var_name'];

    if( !settings.div_id ){
        settings.div_id = this.prefix + 'pliki_div';
    }

    this.o_div = document.getElementById( settings.div_id );

    if( !this.o_div ){
        alert('Bd krytyczny. Nie znaleziono elementu w dokumencie o id: ' + settings.div_id  );
        return false;
    }

    this.o_table = null;

    this.a_items = new Array();
    this.n_item = -1;
    this.mode   = 'add';
    this.b_show_form = false;
    this.o_grid = null;

    this.n_file = 0;

    if( settings.items ){
        this.a_items = settings.items;
    }

    if( settings.extensions ){
        if( typeof(settings.extensions) == 'string'){
            this.extensions = settings.extensions.split(',');
        }else{
            this.extensions = settings.extensions;
        }

        for(var i = 0 ; i < this.extensions.length; i++ ){
            this.extensions[i]  = this.extensions.replace("/[\. ]/g", "");
        }
    }else{
        this.extensions = ['jpg', 'jpeg', 'gif', 'png'];
    }

    this.file_ext_re = new RegExp("\.(" + this.extensions.join('|') + "){1}$", "i");

    this.o_form_div = document.getElementById( this.prefix + 'plik_form_div');

    var formularz = ( settings.form_name) ? settings.form_name : this.prefix + 'plik_form';
    this.o_form = document.forms[formularz];
    if( !this.o_form ){
        alert('Bd krytyczny. Nie znaleziono w dokumencie formularza: ' + formularz  );
        return false;
    }
    
    this.o_usun_btn =  document.getElementById( this.prefix + 'plik_usun_btn');
    this.o_preview_div =  document.getElementById( this.prefix + 'plik_preview');
    
    //pole w formularzu jak bd si nazywa zaanczane plik
    this.s_form_field = ( settings.form_field) ? settings.form_field : this.prefix + 'pliki';
    //jest to nazw do tablicy _FILE w php do kolejnych plikw dostaniemy seu _FILE[this.s_file_input_name.'_'.$num]
    this.s_file_input_name = ( settings.file_input_name) ? settings.file_input_name : this.prefix + 'plik';

    this.show_form = plik_show_form;
    this.anuluj = plik_anuluj;

    this.init  = pliki_init;
    this.make_tr = pliki_make_tr;
    this.print = pliki_print;

    this.add_edit = plik_add_edit;

    this.usun   = plik_usun;
    
    this.up = plik_up;
    this.down = plik_down;

    this.init();
}

function pliki_init(){
    this.o_table = document.createElement('TABLE');
    this.o_table.id = this.prefix + 'pliki_grid';
    this.o_table.className = 'grid';
    this.o_table.style.width = '100%';
    this.o_table.cellPadding = 2;
    this.o_table.cellSpacing = 0;

    o_tbody = document.createElement('TBODY');

    o_tr = document.createElement('TR');
    var o_td = document.createElement('TH');
    o_td.innerHTML = 'Lp.';
    o_td.width = '20px';
    o_tr.appendChild(o_td);

    o_td = document.createElement('TH');
    o_td.appendChild( document.createTextNode('Podgld'));
    o_td.width = '110px';
    o_tr.appendChild(o_td);

    o_td = document.createElement('TH');
    o_td.appendChild( document.createTextNode('Plik'));
    o_tr.appendChild(o_td);

    o_tbody.appendChild(o_tr);

    this.o_table.appendChild(o_tbody);
    this.o_div.innerHTML = "";
    this.o_div.appendChild( this.o_table );

    this.o_msg_div = document.createElement('div');
    if( this.o_div.nextSibling ){
        this.o_div.parentNode.insertBefore( this.o_msg_div, this.o_div.nextSibling);
    }else{
        this.o_div.parentNode.appendChild( this.o_msg_div);

    }

    this.o_msg_div.innerHTML = plik_msg( this.a_items.length, this.max);

    if( this.a_items.length > 0 ){
         this.print();
    }

}

function plik_show_form( action ){
    var o_self = this;

    if( this.simple ) return;
    
    this.mode = action;

    if( action == 'edit' ){
        if( this.o_usun_btn ) this.o_usun_btn.style.display = '';

        if( arguments.length > 1 ){
            this.n_item = arguments[1];
        }

        if( this.n_item  < 0 ){
            alert('Kliknij dwa razy na zacznik aby go edytowa lub kliknij raz na towar_opakowanie, a nastpnie wcinij przycisk edycja.');

            return;
        }else if(this.n_item  > this.a_items.length ){
            this.n_item = this.a_items.length;
        }
    }else{
        if( this.o_usun_btn ) this.o_usun_btn.style.display = 'none';

        this.n_item = this.a_items.length;
    }

    try{ showTlo(); }catch(e){ }

/******************************************************************************/

    if( typeof(this.a_items[this.n_item]) == 'object' ){
        var o_item = this.a_items[this.n_item];

        if( this.o_form.elements.ROZPAKUJ )
            this.o_form.elements['ROZPAKUJ'].checked = (o_item.ROZPAKUJ == 1);

        this.o_form.elements['UWAGI'].value = o_item.UWAGI;
        this.o_form.elements['NAZWA'].value = o_item.NAZWA;

        if( this.a_items[this.n_item].file_input ){
            var o_finput = this.a_items[this.n_item].file_input.cloneNode(true);
            o_finput.name = 'plik';
            o_finput.style.display = '';

            this.o_form.elements['plik'].parentNode.replaceChild(o_finput, this.o_form.elements['plik'] );
        }
    }

    center_both_obj( this.o_form_div );

    this.o_form.elements['plik'].focus();

    add_event( 'keydown', document, function( e ){
        e = (!e) ? window.event : e;

        // pobiera kod znaku nacinitego klawisza
        var code = (e.charCode) ? e.charCode :((e.keyCode) ? e.keyCode :((e.which) ? e.which : 0));

        if( code == 27 ){
            o_self.anuluj();
        }
    }, false );

    this.b_show_form = true;

/******************************************************************************/

}

function plik_anuluj(){

    if( this.mode == 'edit' ){
        this.o_form.reset();
    }

    remove_event( 'keydown', document );

    hide_obj( this.o_form_div );

    try{ hideTlo(); }catch(e){}

    this.b_show_form = false;
}




function plik_usun( num, o_tr ){
    var o_self = this;

    if( arguments.length  > 0 ){
        this.n_item = num;
    }
    if( arguments.length  < 2 ){
        var o_tr_list = this.o_table.getElementsByTagName('TR');
        o_tr = o_tr_list.item(this.n_item+1);
    }

    this.o_tr = o_tr;

    if( this.n_item <  0 || this.n_item >= this.a_items.length ){
        alert('Kliknij najpierw na zaacznik, a nastpnie wcinij klawisz delete lub przyscisk usu.');
        return;
    }

    if( !confirm('Jeste pewien, e chcesz usun zacznik?' ) ){
        return;
    }

    var o_item = this.a_items.splice(this.n_item, 1);

    if( this.n_item >= this.a_items.length ){
        var o_tr_new = o_tr.previousSibling;

        this.n_item = this.a_items.length - 1;

        o_tr.parentNode.removeChild( o_tr );

        if( this.n_item >= 0 ){
            podswietl_wiersz( o_tr_new );
        }
    }else{
        var o_tr_new = o_tr.nextSibling;

        o_tr.parentNode.removeChild( o_tr );

        var o_td, i  = this.n_item;

        var o_tr_highlight = o_tr_new;

        while( o_tr_new ){
            //console.log(o_tr.nodeName);

            if( o_tr_new.nodeName == 'TR' ){
                o_td = o_tr_new.firstChild;
                o_td.innerHTML = (i+1) + '. ';
                o_tr_new.className = 'wiersz' + ( (i%2) + 1 );

                var num = i;

                o_tr_new.onclick = function(){
                    o_self.n_item = num;
                    podswietl_wiersz( this );
                };
                o_tr_new.ondblclick = function(){
                    o_self.show_form('edit', num);
                };

                i++;
            }

            o_tr_new = o_tr_new.nextSibling;
        }

        podswietl_wiersz( o_tr_highlight );
    }

    if( this.b_show_form ){
        this.anuluj();
    }
    
    this.o_msg_div.innerHTML = plik_msg( this.a_items.length, this.max );

/*
    if( this.o_form ){
        var o_input  = document.createElement('INPUT');
        o_input.type  = 'hidden';
        o_input.name  = 'pliki2delete[]';
        o_input.value = o_item['ID'];

        this.o_form.appendChild( o_input );
    }
*/
}

function plik_up( num, o_tr ){
    var o_self = this;

    if( arguments.length  > 0 ){
        this.n_item = num;
    }
    if( arguments.length  < 2 ){
        var o_tr_list = this.o_table.getElementsByTagName('TR');
        o_tr = o_tr_list.item(this.n_item+1);
        console.log('dsfdsfsda');
    }

    this.o_tr = o_tr;

    if( this.n_item <  0 || this.n_item >= this.a_items.length ){
        alert('Kliknij najpierw na plik, a nastpnie wcinij klawisz ctr+up lub przyscisk do gry.');
        return;
    }

    if( this.n_item > 0 ){
        var o_item = this.a_items[this.n_item];
        this.a_items[this.n_item] = this.a_items[this.n_item-1];
        this.a_items[this.n_item-1] = o_item;

        var o_tr_prev = o_tr.previousSibling;
        o_tr.parentNode.removeChild( o_tr );
        o_tr_prev.parentNode.insertBefore( o_tr, o_tr_prev );

        var o_tr_new, i, lp;
        var a_array = [o_tr, o_tr_prev ];

        this.n_item--;
        
        for( i = 0; i < 2; i++ ){
            o_tr_new = a_array[i];
            lp = this.n_item + i;
            
            o_tr_new.firstChild.innerHTML = (lp+1) + '. ';
            o_tr_new.className = 'wiersz' + ( (lp%2) + 1 );
        }
        podswietl_wiersz(o_tr);
    }else{
        alert('Nie mona przesun pliku do gry.');
    }

    if( this.b_show_form ){
        this.anuluj();
    }
}

function plik_down( num, o_tr ){
    var o_self = this;

    if( arguments.length  > 0 ){
        this.n_item = num;
    }
    if( arguments.length  < 2 ){
        var o_tr_list = this.o_table.getElementsByTagName('TR');
        o_tr = o_tr_list.item(this.n_item+1);
    }

    this.o_tr = o_tr;

    if( this.n_item <  0 || this.n_item >= this.a_items.length ){
        alert('Kliknij najpierw na plik, a nastpnie wcinij klawisz ctr+down lub przyscisk "do dou".');
        return;
    }
    
    
    if( this.n_item < this.a_items.length - 1){
        var o_item = this.a_items[this.n_item];
        this.a_items[this.n_item] = this.a_items[this.n_item+1];
        this.a_items[this.n_item+1] = o_item;
        
        var o_tr_next = o_tr.nextSibling;
        o_tr.parentNode.removeChild( o_tr );
        
        if( o_tr_next.nextSibling ){
            o_tr_next.parentNode.insertBefore( o_tr, o_tr_next.nextSibling );
        }else{
            o_tr_next.parentNode.appendChild( o_tr );
        }
        
        var o_td, o_tr_new, i, lp;
        var a_array = [o_tr_next, o_tr];

        for( i = 0; i < 2; i++ ){
            o_tr_new = a_array[i];
            lp = this.n_item + i;

            o_tr_new.firstChild.innerHTML = (lp+1) + '. ';
            o_tr_new.className = 'wiersz' + ( (lp%2) + 1 );
        }
        this.n_item++;
        
        podswietl_wiersz(o_tr);
    }else{
        alert('Nie mona przesun pliku do dou.');
    }

    if( this.b_show_form ){
        this.anuluj();
    }
}


function plik_add_edit(){

    var o_finput = this.o_form.elements['plik'];

    if (  this.a_items.length >= this.max ){
        alert('Na licie jest ju '+this.max+' plikw. eby doda inny, usu ktry z listy.');

        return false;
    }

    if( o_finput.value == "" ){
        alert('Wska plik na dysku ktry chcesz doczy.');
        return false;
    }

    if ( !this.file_ext_re.test(o_finput.value) ){
        alert("Niepoprawny typ pliku.\nAkceptowane typy plikw to: " + this.extensions.join(", ") + ".");
        return false;
    }

    if( this.simple ){ // tylko dodawanie i usuwanie
        this.n_item = this.a_items.length;
    }
    
    for( var i = 0; i < this.a_items.length; i++ ){
        if( i != this.n_item && ( this.a_items[i].PLIK == o_finput.value ) ){
            alert("Ten plik jest ju na licie.");
            return false;
        }
    }

    var ID = ( this.n_item < this.a_items.length) ? this.a_items[this.n_item].ID : 0;

    var NAZWA, UWAGI, ROZPAKUJ = 0;
    
    if( this.simple ){
        NAZWA = o_finput.value;
        UWAGI = '';
    }else{
        NAZWA = this.o_form.elements.NAZWA.value;
        if( NAZWA == "" ){
            NAZWA = o_finput.value;
        }
        UWAGI = this.o_form.elements.UWAGI.value;

        if( this.o_form.elements.ROZPAKUJ )
            ROZPAKUJ = (this.o_form.elements.ROZPAKUJ.checked ? 1 :0);

    }

    var file_id = (++this.n_file);
    
    var o_file_input = o_finput.cloneNode(true);
    o_file_input.name = this.s_file_input_name + "_" + (file_id);
    o_file_input.id   = "";
    o_file_input.style.display = "none";

    this.n_file++
    
    var o_item = {
        'ID'          : ID,
        'NAZWA'       : NAZWA,
        'PLIK'        : o_file_input.value,
        'file_input'  : o_file_input,
        'file_id'     : file_id,
        'ROZPAKUJ'    : ROZPAKUJ,
        'UWAGI'       : UWAGI,
        'zmieniony'   : 1
    };


    var o_tr = null;
    if( (this.n_item+1) < this.o_table.rows.length  ){
        for( var a in o_item ){
            this.a_items[this.n_item][a] = o_item[a];
        }
        
        o_tr = this.o_table.rows[this.n_item+1];
        while ( o_tr.childNodes.length >= 1 ){
            o_tr.removeChild( o_tr.firstChild );
        }
        this.make_tr( o_tr, this.n_item );
    }else{
        this.a_items[this.n_item] = o_item;
    
        o_tr = document.createElement('TR');
        this.make_tr( o_tr, this.n_item );
        this.o_table.firstChild.appendChild( o_tr );

        this.o_msg_div.innerHTML = plik_msg( this.a_items.length, this.max );
    }
    
    if( this.b_show_form ){
        //this.o_form.reset();
        this.anuluj();
    }else if( this.simple ){
        var o_finput = document.createElement('input');
        o_finput.name = 'plik';
        o_finput.type = 'file';

        o_finput.className = this.o_form.elements['plik'].className;
        o_finput.size = this.o_form.elements['plik'].size;
        o_finput.onchange = this.o_form.elements['plik'].onchange;
        
        this.o_form.elements['plik'].parentNode.replaceChild(o_finput, this.o_form.elements['plik'] );
    }
}


function pliki_make_tr( o_tr, i ){
    var o_plik = this.a_items[i];

    var o_td = document.createElement('TD');
    o_td.appendChild(document.createTextNode(( i + 1 )+ "."));

    var o_input = null;

    if( this.simple ){}
    
    var t = ['NAZWA', 'UWAGI', 'ROZPAKUJ', 'zmieniony' ];
    for( a  in o_plik  ){
        if( typeof(o_plik[a]) !== 'object'  ){
            o_input = document.createElement('input');
            o_input.type='hidden'
            o_input.name  = this.s_form_field + '[' + i +']['+ a +']';
            o_input.value = o_plik[a];
            o_td.appendChild( o_input );
        }
    }
    
    o_tr.appendChild(o_td);

    o_td = document.createElement('TD');
    o_td.align ="center";

    var o_img = document.createElement('img');
    o_img.alt = o_plik.NAZWA;

    if( o_plik.file_input ){
      	if( o_plik.file_input.files ){
            o_img.src = o_plik.file_input.files.item(0).getAsDataURL();
      	}else{
            o_img.src = o_plik.file_input.value;
        }

        var szerokosc = this.szerokosc;
        var wysokosc = this.wysokosc;

        o_img.onload = function(){
            var w = this.width;
            var h = this.height;

            if( w > szerokosc || h > wysokosc ){
                var skala = Math.min(szerokosc / w, wysokosc / h);

                this.width = skala * w;
                this.height = skala * h;
            }
        }

        o_td.appendChild( o_img );
    }else if( o_plik.ID > 0 || o_plik.URL ){
        if( o_plik.PREVIEW_URL ){
            o_img.src = o_plik.PREVIEW_URL;
        }else{
            o_img.src = UPLOAD_URL + '/pliki/mini/' + o_plik.ID + '-' + o_plik.PLIK;
        }

        o_a = document.createElement('a');
        o_a.href = (o_plik.URL ) ? o_plik.URL  : UPLOAD_URL + '/pliki/' + o_plik.ID + '-' + o_plik.PLIK;
	      o_a.onclick = function (event) { return zoomClick(this, event); };
				o_a.onmouseover = function () { zoomPreload(this);  };

				o_a.appendChild(o_img);

				o_td.appendChild(o_a);
    }


    o_tr.appendChild(o_td);

    o_td = document.createElement('TD');
    o_td.appendChild(document.createTextNode(o_plik.NAZWA));

    if( o_plik.file_input ) o_td.appendChild( o_plik.file_input );

    o_tr.appendChild(o_td);

    var o_self = this;
    o_tr.onclick = function(){
        o_self.n_item = this.rowIndex-1;
        podswietl_wiersz( this );
    }

    o_tr.ondblclick = function(){
        o_self.show_form('edit', this.rowIndex-1);
    }

    o_tr.className = 'wiersz' +(i%2+1);
}


function pliki_print(){
    var i, o_tbody, o_tr = false;

    var o_self = this;

    var o_tr = null;
    var o_tr_highlight = null;

    o_tbody = this.o_table.firstChild;

    for( i = 0; i < this.a_items.length; i++ ){
        o_tr = document.createElement('TR');
        this.make_tr( o_tr, i );
        o_tbody.appendChild( o_tr );

        if( i == this.n_item ){
            o_tr_highlight = o_tr;
            o_tr.className += ' highlight';
        }
    }

    podswietl_wiersz( o_tr_highlight );

    this.o_msg_div.innerHTML = plik_msg( this.a_items.length, this.max );

/**************************************************************************************************/

    grid_settings = {
        'ondelete' : function(){ o_self.usun(arguments[0], arguments[1]) },
        'onctrlup' : function(){ o_self.up(arguments[0], arguments[1]) },
        'onctrldown' : function(){ o_self.down(arguments[0], arguments[1]) }
    }
    
    if( !this.simple ){
        grid_settings.onenter = function(){ o_self.show_form('edit', arguments[0], arguments[1]) };
        grid_settings.oninsert = function(){ o_self.show_form('add') };
    }
    
    this.o_grid = new Grid( this.prefix + 'pliki_grid', grid_settings);
}



function plik_msg( cnt, max ){
    var msg_str = new String();

    if (  cnt==0) {
        if (  max==1) {
          file_str='plik';
        }else if (  max>=2 &&   max<=4) {
          file_str='pliki';
        }else if (  max>=5 &&   max<=19) {
          file_str='pliki';
        }

        msg_str = 'Moesz doda maksymalnie ' + max + ' plikw.';
    }else if (  cnt==  max) {
        msg_str = 'Na licie jest ju '+  max+' plikw. eby doda inny, usu ktry z listy.';
    } else {
        var max_minus_cnt = max-cnt
        if (  (max_minus_cnt) == 1) {
            file_str = 'plik';
        }else if (  (max_minus_cnt) >= 2 &&   max_minus_cnt <= 4) {
            file_str = 'pliki';
        }else{
            file_str = 'plikw';
        }

        msg_str = 'Moesz doda jeszcze '+( max_minus_cnt )+' ' + file_str + '.';
    }

    return msg_str;
}
/**************************************************************************************************/

