// Title: Tigra Tree
// Description: See the demo at url
// URL: http://www.softcomplex.com/products/tigra_menu_tree/
// Version: 1.1
// Date: 11-12-2002 (mm-dd-yyyy)
// Notes: This script is free. Visit official site for further details.

var o_ajax_tree = createXmlHttpRequestObject();

function tree (a_items, a_template) {

	this.a_tpl      = a_template;
	this.a_config   = a_items;
	this.o_root     = this;
	this.a_index    = [];
	this.o_selected = null;
	this.n_depth    = -1;

	var o_icone = new Image(),
	    o_iconl = new Image();
	o_icone.src = a_template['icon_e'];
	o_iconl.src = a_template['icon_l'];
	a_template['im_e'] = o_icone;
	a_template['im_l'] = o_iconl;
	for (var i = 0; i < 64; i++)
		if (a_template['icon_' + i]) {
			var o_icon = new Image();
			a_template['im_' + i] = o_icon;
			o_icon.src = a_template['icon_' + i];
		}

	this.toggle = function (n_id) {	var o_item = this.a_index[n_id]; o_item.open(o_item.b_opened) };
	this.select = function (n_id) { return this.a_index[n_id].select(); };
	this.mout   = function (n_id) { this.a_index[n_id].upstatus(true) };
	this.mover  = function (n_id) { this.a_index[n_id].upstatus() };

	this.a_children = [];
	for (var i = 0; i < a_items.length; i++)
		new tree_item(this, i);

	this.n_id = trees.length;
	trees[this.n_id] = this;

	for (var i = 0; i < this.a_children.length; i++) {
		this.a_children[i].init_once();
	}

  if( this.o_selected )
	 this.o_selected.select();
}

function tree_item (o_parent, n_order) {

	this.n_depth  = o_parent.n_depth + 1;
	this.a_config = o_parent.a_config[n_order + (this.n_depth ? 4 : 0)];

	if (!this.a_config) return;

	this.o_root    = o_parent.o_root;
	this.o_parent  = o_parent;
	this.n_order   = n_order;
  this.b_opened  = this.a_config[2];
  this.b_selected  = this.a_config[3];
  
  if( this.b_selected  ){
      this.o_root.o_selected = this;
  }

	this.n_id = this.o_root.a_index.length;
	this.o_root.a_index[this.n_id] = this;
	o_parent.a_children[n_order] = this;

	this.a_children = [];

  if( this.a_config[4] == true ){

  }else if( typeof(this.a_config[4]) == 'object' ){
    	for ( var i = 0; i < this.a_config.length - 4; i++)
          new tree_item(this, i);

  }

	this.get_icon = item_get_icon;
	this.open     = item_open;
	this.select   = item_select;
  this.init_once= item_init_once;
  this.init     = item_init;

	this.upstatus = item_upstatus;
	this.is_last  = function () { return this.n_order == this.o_parent.a_children.length - 1 };

}

function item_open (b_close) {
	var o_idiv = get_element('i_div' + this.o_root.n_id + '_' + this.n_id);
	if (!o_idiv) return;

  //alert('innerHTML=' + o_idiv.innerHTML + ',\nouterHTML=' + o_idiv.outerHTML + ',');
  
	if ( !o_idiv.innerHTML ) {
		var a_children = [];
		for (var i = 0; i < this.a_children.length; i++)
			a_children[i]= this.a_children[i].init();
		o_idiv.innerHTML = a_children.join('');
	}
	o_idiv.style.display = (b_close ? 'none' : 'block');
	this.b_opened = !b_close;

	//o_idiv.style.display = (this.b_opened ?'block' : 'none'  );
	//this.b_opened = !this.b_opened;
	var o_jicon = document.images['j_img' + this.o_root.n_id + '_' + this.n_id],
	    o_iicon = document.images['i_img' + this.o_root.n_id + '_' + this.n_id];
	if (o_jicon) o_jicon.src = this.get_icon(true);
	if (o_iicon) o_iicon.src = this.get_icon();
	this.upstatus();
}

function item_select (b_deselect) {

  if ( !b_deselect ) {
		var o_olditem = this.o_root.o_selected;
		this.o_root.o_selected = this;
		if (o_olditem) o_olditem.select(true);
	}
	
	//var o_iicon = document.images['i_img' + this.o_root.n_id + '_' + this.n_id];
	//if (o_iicon) o_iicon.src = this.get_icon();

  var el = get_element('i_txt' + this.o_root.n_id + '_' + this.n_id);
  if( b_deselect ){
    el.className = 't' + this.o_root.n_id + 'i';
  }else{
    el.className = 't' + this.o_root.n_id + 'i_selected';
  }

  get_element('i_txt' + this.o_root.n_id + '_' + this.n_id).style.fontWeight = b_deselect ? 'normal' : 'bold';
	
	
	//get_element('i_txt' + this.o_root.n_id + '_' + this.n_id).style.border = b_deselect ? '' : 'solid 1px blue;';
	//get_element('i_td' + this.o_root.n_id + '_' + this.n_id).style.background = b_deselect ? '' : '#efefef';

	this.upstatus();
	return Boolean(this.a_config[1]);
}

function item_upstatus (b_clear) {
  //alert(this.a_config[1].replace(/"/g,'\\"'));
	window.setTimeout('window.status="' + (b_clear ? '' : this.a_config[0].replace(/"/g,'\\"') + (this.a_config[1] ? ' ('+ this.a_config[1].replace(/"/g, '\\"') + ')' : '')) + '"', 10);
}

function item_init(){
	var a_offset = [],
	o_current_item = this.o_parent;
	for (var i = this.n_depth; i > 1; i--) {
		a_offset[i] = '<img src="' + this.o_root.a_tpl[o_current_item.is_last() ? 'icon_e' : 'icon_l'] + '" border="0" align="absbottom">';
		o_current_item = o_current_item.o_parent;
	}

  var a_found = [];
  var img = '';
  if( a_found = this.a_config[0].match(/<img[^>]+> /) ){
      this.a_config[0] = this.a_config[0].replace(/<img[^>]+> /, '')
      var img = a_found[0];
  }else{
      img = ' ';
  }
  
	if(this.n_depth == 0){
        
        if( this.a_config[0].length > 20 ){
    	      pos = 0; pos1 = this.a_config[0].indexOf(' ');
              while( pos1 != -1 && pos1 < 16 ){
                pos = pos1;  pos1 = this.a_config[0].indexOf(' ', pos+1);
              }

              if(pos == 0){ pos = 16; }

	          return '<table cellpadding="0" cellspacing="0" border="0" class=tree_tab><tr><td nowrap id="i_td'+ this.o_root.n_id + '_' + this.n_id+'" >' + (this.n_depth ? a_offset.join('') + (this.a_children.length
                     ? '<a href="javascript: trees[' + this.o_root.n_id + '].toggle(' + this.n_id + ')" onmouseover="trees[' + this.o_root.n_id + '].mover(' + this.n_id + ')" onmouseout="trees[' + this.o_root.n_id + '].mout(' + this.n_id + ')"><img src="' + this.get_icon(true) + '" border="0" align="absbottom" name="j_img' + this.o_root.n_id + '_' + this.n_id + '"></a>'
                     : '<img src="' + this.get_icon(true) + '" border="0" align="absbottom">') : '')
                     + '<a href="' + this.a_config[1] + '" target="' + this.o_root.a_tpl['target'] + '" onclick="return trees[' + this.o_root.n_id + '].select(' + this.n_id + ')" ondblclick="trees[' + this.o_root.n_id + '].toggle(' + this.n_id + ')" onmouseover="overlib(\'' + this.config[0] + '\')trees[' + this.o_root.n_id + '].mover(' + this.n_id + ')" onmouseout="trees[' + this.o_root.n_id + '].mout(' + this.n_id + ')" class="t' + this.o_root.n_id + 'i" id="i_txt' + this.o_root.n_id + '_' + this.n_id + '"><img src="' + this.get_icon() + '" border="0" align="absbottom" name="i_img' + this.o_root.n_id + '_' + this.n_id + '" class="t' + this.o_root.n_id + 'im">' +img+ this.a_config[0].substr(0,pos) + ' ...</a></td></tr></table>' + (this.a_children.length ? '<div id="i_div' + this.o_root.n_id + '_' + this.n_id + '" style="display:none"></div>' : '');

        }else{
	          return '<table cellpadding="0" cellspacing="0" border="0" class=tree_tab><tr><td nowrap id="i_td'+ this.o_root.n_id + '_' + this.n_id+'" >' + (this.n_depth ? a_offset.join('') + (this.a_children.length
                     ? '<a href="javascript: trees[' + this.o_root.n_id + '].toggle(' + this.n_id + ')" onmouseover="trees[' + this.o_root.n_id + '].mover(' + this.n_id + ')" onmouseout="trees[' + this.o_root.n_id + '].mout(' + this.n_id + ')"><img src="' + this.get_icon(true) + '" border="0" align="absbottom" name="j_img' + this.o_root.n_id + '_' + this.n_id + '"></a>'
                     : '<img src="' + this.get_icon(true) + '" border="0" align="absbottom">') : '')
                     + '<a href="' + this.a_config[1] + '" target="' + this.o_root.a_tpl['target'] + '" onclick="return trees[' + this.o_root.n_id + '].select(' + this.n_id + ')" ondblclick="trees[' + this.o_root.n_id + '].toggle(' + this.n_id + ')" onmouseover="trees[' + this.o_root.n_id + '].mover(' + this.n_id + ')" onmouseout="trees[' + this.o_root.n_id + '].mout(' + this.n_id + ')" class="t' + this.o_root.n_id + 'i" id="i_txt' + this.o_root.n_id + '_' + this.n_id + '"><img src="' + this.get_icon() + '" border="0" align="absbottom" name="i_img' + this.o_root.n_id + '_' + this.n_id + '" class="t' + this.o_root.n_id + 'im">' +img+ this.a_config[0] + '</a></td></tr></table>' + (this.a_children.length ? '<div id="i_div' + this.o_root.n_id + '_' + this.n_id + '" style="display:none"></div>' : '');
        }
    }else{
        if( this.a_config[0].length > 20 ){
    	      pos = 0; pos1 = this.a_config[0].indexOf(' ');
              while( pos1 != -1 && pos1 < 16 ){
                pos = pos1;  pos1 = this.a_config[0].indexOf(' ', pos+1);
              }

              if(pos == 0){ pos = 16; }

              return '<table cellpadding="0" cellspacing="0" border="0" class=tree_tab><tr><td nowrap id="i_td'+ this.o_root.n_id + '_' + this.n_id+'" >' + (this.n_depth ? a_offset.join('') + (this.a_children.length
                    ? '<a href="javascript: trees[' + this.o_root.n_id + '].toggle(' + this.n_id + ')" onmouseover="trees[' + this.o_root.n_id + '].mover(' + this.n_id + ')" onmouseout="trees[' + this.o_root.n_id + '].mout(' + this.n_id + ')"><img src="' + this.get_icon(true) + '" border="0" align="absbottom" name="j_img' + this.o_root.n_id + '_' + this.n_id + '"></a>'
                    : '<img src="' + this.get_icon(true) + '" border="0" align="absbottom">') : '')
                    + '<a href="' + this.a_config[1] + '" target="' + this.o_root.a_tpl['target'] + '" onclick="return trees[' + this.o_root.n_id + '].select(' + this.n_id + ')" ondblclick="trees[' + this.o_root.n_id + '].toggle(' + this.n_id + ')" onmouseover="overlib(\'' + this.a_config[0] + '\');trees[' + this.o_root.n_id + '].mover(' + this.n_id + ')" onmouseout="nd();trees[' + this.o_root.n_id + '].mout(' + this.n_id + ')" class="t' + this.o_root.n_id + 'i" id="i_txt' + this.o_root.n_id + '_' + this.n_id + '">'+img + this.a_config[0].substr(0,pos) + ' ...</a></td></tr></table>' + (this.a_children.length ? '<div id="i_div' + this.o_root.n_id + '_' + this.n_id + '" style="display:none"></div>' : '');

        }else{
              return '<table cellpadding="0" cellspacing="0" border="0" class=tree_tab><tr><td nowrap id="i_td'+ this.o_root.n_id + '_' + this.n_id+'" >' + (this.n_depth ? a_offset.join('') + (this.a_children.length
                    ? '<a href="javascript: trees[' + this.o_root.n_id + '].toggle(' + this.n_id + ')" onmouseover="trees[' + this.o_root.n_id + '].mover(' + this.n_id + ')" onmouseout="trees[' + this.o_root.n_id + '].mout(' + this.n_id + ')"><img src="' + this.get_icon(true) + '" border="0" align="absbottom" name="j_img' + this.o_root.n_id + '_' + this.n_id + '"></a>'
                    : '<img src="' + this.get_icon(true) + '" border="0" align="absbottom">') : '')
                    + '<a href="' + this.a_config[1] + '" target="' + this.o_root.a_tpl['target'] + '" onclick="return trees[' + this.o_root.n_id + '].select(' + this.n_id + ')" ondblclick="trees[' + this.o_root.n_id + '].toggle(' + this.n_id + ')" onmouseover="trees[' + this.o_root.n_id + '].mover(' + this.n_id + ')" onmouseout="trees[' + this.o_root.n_id + '].mout(' + this.n_id + ')" class="t' + this.o_root.n_id + 'i" id="i_txt' + this.o_root.n_id + '_' + this.n_id + '">' + img + this.a_config[0] + '</a></td></tr></table>' + (this.a_children.length ? '<div id="i_div' + this.o_root.n_id + '_' + this.n_id + '" style="display:none"></div>' : '');
        }
    }


}


function item_init_once () {
	var a_offset = [],
	o_current_item = this.o_parent;
	for (var i = this.n_depth; i > 1; i--) {
		a_offset[i] = '<img src="' + this.o_root.a_tpl[o_current_item.is_last() ? 'icon_e' : 'icon_l'] + '" border="0" align="absbottom">';
		o_current_item = o_current_item.o_parent;
	}

  var a_found = [];
  var img = '';
  if( a_found = this.a_config[0].match(/<img[^>]+> /) ){
      this.a_config[0] = this.a_config[0].replace(/<img[^>]+> /, '')
      var img = a_found[0];
  }else{
      img = ' ';
  }
  
	if(this.n_depth == 0){
	   if( this.a_config[0].length > 20 ){
	      pos = 0; pos1 = this.a_config[0].indexOf(' ');
          while( pos1 != -1 && pos1 < 16 ){
            pos = pos1; pos1 = this.a_config[0].indexOf(' ',pos+1);
          }
          if(pos == 0){ pos = 16; }

          var html = '<table cellpadding="0" cellspacing="0" border="0" class=tree_tab><tr><td nowrap id="i_td'+ this.o_root.n_id + '_' + this.n_id+'" >' + (this.n_depth ? a_offset.join('') + (this.a_children.length
                     ? '<a href="javascript: trees[' + this.o_root.n_id + '].toggle(' + this.n_id + ')" onmouseover="trees[' + this.o_root.n_id + '].mover(' + this.n_id + ')" onmouseout="trees[' + this.o_root.n_id + '].mout(' + this.n_id + ')"><img src="' + this.get_icon(true) + '" border="0" align="absbottom" name="j_img' + this.o_root.n_id + '_' + this.n_id + '"></a>'
                     : '<img src="' + this.get_icon(true) + '" border="0" align="absbottom">') : '')
                     + '<a href="' + this.a_config[1] + '" target="' + this.o_root.a_tpl['target'] + '" onclick="return trees[' + this.o_root.n_id + '].select(' + this.n_id + ')" ondblclick="trees[' + this.o_root.n_id + '].toggle(' + this.n_id + ')" onmouseover="overlib(\''+ this.config[0] +'\');trees[' + this.o_root.n_id + '].mover(' + this.n_id + ')" onmouseout="nd(); trees[' + this.o_root.n_id + '].mout(' + this.n_id + ')" class="t' + this.o_root.n_id + 'i" id="i_txt' + this.o_root.n_id + '_' + this.n_id + '"><img src="' + this.get_icon() + '" border="0" align="absbottom" name="i_img' + this.o_root.n_id + '_' + this.n_id + '" class="t' + this.o_root.n_id + 'im">' +img + this.a_config[0].substr(0,pos) + ' ...</a></td></tr></table>' ;

       }else{
	      var html = '<table cellpadding="0" cellspacing="0" border="0" class=tree_tab><tr><td nowrap id="i_td'+ this.o_root.n_id + '_' + this.n_id+'" >' + (this.n_depth ? a_offset.join('') + (this.a_children.length
                     ? '<a href="javascript: trees[' + this.o_root.n_id + '].toggle(' + this.n_id + ')" onmouseover="trees[' + this.o_root.n_id + '].mover(' + this.n_id + ')" onmouseout="trees[' + this.o_root.n_id + '].mout(' + this.n_id + ')"><img src="' + this.get_icon(true) + '" border="0" align="absbottom" name="j_img' + this.o_root.n_id + '_' + this.n_id + '"></a>'
                     : '<img src="' + this.get_icon(true) + '" border="0" align="absbottom">') : '')
                     + '<a href="' + this.a_config[1] + '" target="' + this.o_root.a_tpl['target'] + '" onclick="return trees[' + this.o_root.n_id + '].select(' + this.n_id + ')" ondblclick="trees[' + this.o_root.n_id + '].toggle(' + this.n_id + ')" onmouseover="trees[' + this.o_root.n_id + '].mover(' + this.n_id + ')" onmouseout="trees[' + this.o_root.n_id + '].mout(' + this.n_id + ')" class="t' + this.o_root.n_id + 'i" id="i_txt' + this.o_root.n_id + '_' + this.n_id + '"><img src="' + this.get_icon() + '" border="0" align="absbottom" name="i_img' + this.o_root.n_id + '_' + this.n_id + '" class="t' + this.o_root.n_id + 'im">' + img + this.a_config[0] + '</a></td></tr></table>' ;
       }

    }else{
	   if( this.a_config[0].length > 20 ){
	      pos = 0; pos1 = this.a_config[0].indexOf(' ');
          while( pos1 != -1 && pos1 < 16 ){
            pos = pos1;  pos1 = this.a_config[0].indexOf(' ',pos+1);
          }
          if(pos == 0){ pos = 16; }

          var html = '<table cellpadding="0" cellspacing="0" border="0" class=tree_tab><tr><td nowrap id="i_td'+ this.o_root.n_id + '_' + this.n_id+'" >' + (this.n_depth ? a_offset.join('') + (this.a_children.length
                     ? '<a href="javascript: trees[' + this.o_root.n_id + '].toggle(' + this.n_id + ')" onmouseover="trees[' + this.o_root.n_id + '].mover(' + this.n_id + ')" onmouseout="trees[' + this.o_root.n_id + '].mout(' + this.n_id + ')"><img src="' + this.get_icon(true) + '" border="0" align="absbottom" name="j_img' + this.o_root.n_id + '_' + this.n_id + '"></a>'
                     : '<img src="' + this.get_icon(true) + '" border="0" align="absbottom">') : '')
                     + '<a href="' + this.a_config[1] + '" target="' + this.o_root.a_tpl['target'] + '" onclick="return trees[' + this.o_root.n_id + '].select(' + this.n_id + ')" ondblclick="trees[' + this.o_root.n_id + '].toggle(' + this.n_id + ')" onmouseover="overlib(\'' + this.a_config[0] + '\');trees[' + this.o_root.n_id + '].mover(' + this.n_id + ')" onmouseout="nd();trees[' + this.o_root.n_id + '].mout(' + this.n_id + ')" class="t' + this.o_root.n_id + 'i" id="i_txt' + this.o_root.n_id + '_' + this.n_id + '">' + img + this.a_config[0].substr(0,pos) + ' ...</a></td></tr></table>' ;
       }else{
          var html = '<table cellpadding="0" cellspacing="0" border="0" class=tree_tab><tr><td nowrap id="i_td'+ this.o_root.n_id + '_' + this.n_id+'" >' + (this.n_depth ? a_offset.join('') + (this.a_children.length
                     ? '<a href="javascript: trees[' + this.o_root.n_id + '].toggle(' + this.n_id + ')" onmouseover="trees[' + this.o_root.n_id + '].mover(' + this.n_id + ')" onmouseout="trees[' + this.o_root.n_id + '].mout(' + this.n_id + ')"><img src="' + this.get_icon(true) + '" border="0" align="absbottom" name="j_img' + this.o_root.n_id + '_' + this.n_id + '"></a>'
                     : '<img src="' + this.get_icon(true) + '" border="0" align="absbottom">') : '')
                     + '<a href="' + this.a_config[1] + '" target="' + this.o_root.a_tpl['target'] + '" onclick="return trees[' + this.o_root.n_id + '].select(' + this.n_id + ')" ondblclick="trees[' + this.o_root.n_id + '].toggle(' + this.n_id + ')" onmouseover="trees[' + this.o_root.n_id + '].mover(' + this.n_id + ')" onmouseout="trees[' + this.o_root.n_id + '].mout(' + this.n_id + ')" class="t' + this.o_root.n_id + 'i" id="i_txt' + this.o_root.n_id + '_' + this.n_id + '">' + img + this.a_config[0] + '</a></td></tr></table>' ;
       }

    }

        document.write(html);

        if( this.a_children.length > 0 ){
            if( this.b_opened ){
                document.write('<div id="i_div' + this.o_root.n_id + '_' + this.n_id + '" style="display:block;">');
                for (var i = 0; i < this.a_children.length; i++) {
                     this.a_children[i].init_once();
                     //this.a_children[i].open();
                }
                document.write('</div>');
             }else{
                document.write('<div id="i_div' + this.o_root.n_id + '_' + this.n_id + '" style="display: none;"></div>');
             }

        }
}

function item_get_icon (b_junction) {
	return this.o_root.a_tpl['icon_' + ((this.n_depth ? 0 : 32) + (this.a_children.length ? 16 : 0) + (this.a_children.length && this.b_opened ? 8 : 0) + (!b_junction && this.o_root.o_selected == this ? 4 : 0) + (b_junction ? 2 : 0) + (b_junction && this.is_last() ? 1 : 0))];
}

var trees = [];
get_element = document.all ?
  function (s_id) { return document.all[s_id] } :
  function (s_id) { return document.getElementById(s_id) };



function tree_handle_response( xmlRoot ){

    var o_alarmy_xml = xmlRoot.getElementsByTagName('alarm');
    var o_alarm_xml = new Object();
    var o_alarm = new Object();

    var o_errors_xml = xmlRoot.getElementsByTagName('error');

    if( o_errors_xml && o_errors_xml.length > 0 ){

        var errors = [];

        var err_str = 'W trakcie pobierania alarmw wystpiy nastpujce bdy: '+ "\n";

        // przeszukuje w ptli wszystkie wzy XML, pobierajc ich zawarto
        for(var i = 0; i < o_errors_xml.length; i++){
            errors[i] = o_errors_xml.item(i).getAttribute('str');
            err_str += errors[i] + "\n";
        }

        alert( err_str );
        return;
    }else{
/*
        kontrahent_id = parseInt(o_towar_xml.getAttribute( 'ID' ));
        if( isNaN(kontrahent_id) ){
            alert('Nie zosta zwrcony identyfikator kontrahenta.');
            return;
        }
*/
        //zeruje alarmy
        alarmy = new Array();

        var atrybuty = ['TRESC', 'UWAGI', 'DATA_OD', 'DATA_DO', 'PRIORYTET'];

        /* pobieramy nowe nazwy funkcji z pliku XML w postaci tablicy */
        var key, value;
        var i, j;

        for( i = 0; i < o_alarmy_xml.length; i++){
            o_alarm_xml = o_alarmy_xml.item(i);

            o_alarm = new Object();

            for( j = 0; j < atrybuty.length; j++){
                key = atrybuty[j];
                value = o_alarm_xml.getAttribute( key );
                o_alarm[key] = value;
            }
            alarmy.push( o_alarm );
        }

        //pokazuje wszytkie alarmy o ile jakies zostay mnie zwrcone
        show_alarm('a');
    }
}
