/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
/**
 * Author:  Jarek
 * Created: 2017-05-08
 */

/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/


CREATE GENERATOR WWW_JOURNAL_ID_GEN;

CREATE TABLE WWW_JOURNAL (
    ID            INTEGER NOT NULL,
    RECORD_TABLE  VARCHAR(50) NOT NULL,
    RECORD_ID     INTEGER NOT NULL,
    EVENT_TYPE    CHAR(1) NOT NULL,
    CREATED       TIMESTAMP NOT NULL
);




/******************************************************************************/
/****                             Primary Keys                             ****/
/******************************************************************************/

ALTER TABLE WWW_JOURNAL ADD CONSTRAINT WWW_JOURNAL_PK PRIMARY KEY (ID);


/******************************************************************************/
/****                               Indices                                ****/
/******************************************************************************/

CREATE INDEX WWW_JOURNAL_CREATED_IND ON WWW_JOURNAL (CREATED);
CREATE INDEX WWW_JOURNAL_EVENT_TYPE_IND ON WWW_JOURNAL (EVENT_TYPE);
CREATE INDEX WWW_JOURNAL_RECORD_ID_IND ON WWW_JOURNAL (RECORD_ID);
CREATE INDEX WWW_JOURNAL_RECORD_IND ON WWW_JOURNAL (RECORD_TABLE, RECORD_ID);
CREATE INDEX WWW_JOURNAL_RECORD_TABLE_IND ON WWW_JOURNAL (RECORD_TABLE);


/******************************************************************************/
/****                               Triggers                               ****/
/******************************************************************************/


SET TERM ^ ;


/******************************************************************************/
/****                         Triggers for tables                          ****/
/******************************************************************************/



/* Trigger: WWW_JOURNAL_BI */
CREATE TRIGGER WWW_JOURNAL_BI FOR WWW_JOURNAL
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(WWW_JOURNAL_ID_GEN,1);
END
^


SET TERM ; ^



/******************************************************************************/
/****                              Privileges                              ****/
/******************************************************************************/


/* Privileges of users */
GRANT ALL ON WWW_JOURNAL TO RAKS3000 WITH GRANT OPTION;

GRANT ALL ON WWW_JOURNAL TO WWW_ROLE;




