GRANT ALL ON R3_EXT_TYPES TO WWW_ROLE;
GRANT ALL ON CRM_LOCATIONS TO WWW_ROLE;
GRANT SELECT ON CRM_RESPONSIBILITIES TO WWW_ROLE;

GRANT SELECT, INSERT ON CRM_SCHEDULER_RESOURCES TO WWW_ROLE;
GRANT SELECT, INSERT ON CRM_SCHEDULER TO WWW_ROLE;

GRANT SELECT ON CRM_EMPLOYEE_COUNT TO WWW_ROLE;

GRANT SELECT ON CRM_CALENDARS TO WWW_ROLE;
GRANT SELECT ON R3_LOGOS TO WWW_ROLE;
GRANT SELECT, UPDATE ON R3_CONTACTS TO WWW_ROLE;
GRANT ALL ON R3_CONTACTS_FIRMS TO WWW_ROLE;
GRANT ALL ON GM_PRZEDSTAWICIELE TO WWW_ROLE;
GRANT ALL ON R3_CONTACT_ADDRESSES TO WWW_ROLE;
GRANT ALL ON R3_CONTACT_PHONES TO WWW_ROLE;
GRANT ALL ON R3_CONTACT_WEB_ADDRESSES TO WWW_ROLE;
GRANT UPDATE ON GM_KONTRAHENCI TO WWW_ROLE;

GRANT SELECT ON GM_ROZMIARY TO WWW_ROLE;

GRANT EXECUTE PROCEDURE R3_CONTACT_GROUPS_TREE_SP TO WWW_ROLE;

GRANT UPDATE (PRODUCENT, DOSTAWCA) ON GM_TOWARY  TO WWW_ROLE;


CREATE EXCEPTION WWW_SPOSOBY_DOSTAWY_BD_EXC 'Nie mona usun tego sposobu dostawy';

ALTER TABLE WWW_SPOSOBY_DOSTAWY ADD DOMYSLNY  BOOLEAN_D DEFAULT 0 NOT NULL;
UPDATE WWW_SPOSOBY_DOSTAWY SET DOMYSLNY = 0;

ALTER TABLE WWW_SPOSOBY_DOSTAWY ADD OPIS STRING250_ISO_D COLLATE ISO8859_2;


ALTER TABLE WWW_SPOSOBY_DOSTAWY
ADD USLUGA INTEGER
DEFAULT 0
NOT NULL ;

UPDATE WWW_SPOSOBY_DOSTAWY
SET USLUGA = 0;


ALTER TABLE WWW_SPOSOBY_DOSTAWY ADD WYSWIETLAJ BOOLEAN_D DEFAULT 1 NOT NULL;
UPDATE WWW_SPOSOBY_DOSTAWY SET WYSWIETLAJ = 1;



SET TERM ^ ;


/******************************************************************************/
/****                         Triggers for tables                          ****/
/******************************************************************************/



/* Trigger: WWW_SPOSOBY_DOSTAWY_BD0 */
CREATE TRIGGER WWW_SPOSOBY_DOSTAWY_BD0 FOR WWW_SPOSOBY_DOSTAWY
ACTIVE BEFORE DELETE POSITION 0
AS
begin
  /* Trigger text */
  if  (old.id < 2) then EXCEPTION WWW_SPOSOBY_DOSTAWY_BD_EXC;
end
^


SET TERM ; ^

/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/


CREATE GENERATOR WWW_REG_ID_GEN;

CREATE TABLE WWW_REG (
    ID           INTEGER NOT NULL,
    GUID         CHAR(36) CHARACTER SET ISO8859_2 NOT NULL,
    IMIE         STRING30_ISO_D /* STRING30_ISO_D = VARCHAR(30) */,
    NAZWISKO     STRING30_ISO_D /* STRING30_ISO_D = VARCHAR(30) */,
    TELEFON      STRING20_ISO_D /* STRING20_ISO_D = VARCHAR(20) */,
    EMAIL        STRING30_ISO_D /* STRING30_ISO_D = VARCHAR(30) */,
    HASLO        STRING20_ISO_D /* STRING20_ISO_D = VARCHAR(20) */,
    FIRMA        BOOLEAN_D /* BOOLEAN_D = SMALLINT DEFAULT 0 NOT NULL CHECK    (VALUE IN (0,1)) */,
    FIRMA_NAZWA  STRING50_ISO_D /* STRING50_ISO_D = VARCHAR(50) */,
    NIP          STRING20_ISO_D /* STRING20_ISO_D = VARCHAR(20) */,
    PLATNIK_VAT  BOOLEAN_D /* BOOLEAN_D = SMALLINT DEFAULT 0 NOT NULL CHECK    (VALUE IN (0,1)) */,
    CONTACT_ID   INTEGER default 0,
    KOD          STRING10_ISO_D /* STRING10_ISO_D = VARCHAR(10) */,
    MIEJSCOWOSC  STRING50_ISO_D /* STRING50_ISO_D = VARCHAR(50) */,
    ULICA        STRING50_ISO_D /* STRING50_ISO_D = VARCHAR(50) */,
    DOM          STRING10_ISO_D /* STRING10_ISO_D = VARCHAR(10) */,
    LOKAL        STRING10_ISO_D /* STRING10_ISO_D = VARCHAR(10) */,
    ZGODA        BOOLEAN_D /* BOOLEAN_D = SMALLINT DEFAULT 0 NOT NULL CHECK    (VALUE IN (0,1)) */,
    ZASADY       BOOLEAN_D /* BOOLEAN_D = SMALLINT DEFAULT 0 NOT NULL CHECK    (VALUE IN (0,1)) */,
    ADRES_IP     STRING15_ISO_D /* STRING15_ISO_D = VARCHAR(15) */,
    REG_DATE     TIMESTAMP
);




/******************************************************************************/
/****                          Unique Constraints                          ****/
/******************************************************************************/

ALTER TABLE WWW_REG ADD CONSTRAINT WWW_REG_GUID_UK UNIQUE (GUID);


/******************************************************************************/
/****                             Primary Keys                             ****/
/******************************************************************************/

ALTER TABLE WWW_REG ADD CONSTRAINT PK_WWW_REG PRIMARY KEY (ID);


/******************************************************************************/
/****                               Triggers                               ****/
/******************************************************************************/


SET TERM ^ ;


/******************************************************************************/
/****                         Triggers for tables                          ****/
/******************************************************************************/



/* Trigger: WWW_REG_BI */
CREATE TRIGGER WWW_REG_BI FOR WWW_REG
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(WWW_REG_ID_GEN,1);
END
^


SET TERM ; ^



/* Fields descriptions */

DESCRIBE FIELD FIRMA TABLE WWW_REG
'Wzr typu dla pl zawierajcych warto logiczn: tak lub nie';

DESCRIBE FIELD PLATNIK_VAT TABLE WWW_REG
'Wzr typu dla pl zawierajcych warto logiczn: tak lub nie';

DESCRIBE FIELD ZGODA TABLE WWW_REG
'Wzr typu dla pl zawierajcych warto logiczn: tak lub nie';

DESCRIBE FIELD ZASADY TABLE WWW_REG
'Wzr typu dla pl zawierajcych warto logiczn: tak lub nie';



/******************************************************************************/
/****                              Privileges                              ****/
/******************************************************************************/


/* Privileges of roles */
GRANT ALL ON WWW_REG TO WWW_ROLE;


ALTER TABLE WWW_USERS ADD WYLACZONE BOOLEAN_D DEFAULT 0;

ALTER table WWW_USERS alter LOGIN type varchar(60) not null;
alter table WWW_USERS add constraint WWW_USERS_LOGIN_UK unique (LOGIN);

ALTER TABLE WWW_USERS ADD LAST_LOGIN_FROM STRING60_D COLLATE PXW_PLK;
ALTER TABLE WWW_USERS ADD POWOD_WYLACZENIA STRING250_D COLLATE PXW_PLK;


alter table WWW_USERS
alter ID position 1;
alter table WWW_USERS
alter HASLO position 2;
alter table WWW_USERS
alter LOGIN position 3;
alter table WWW_USERS
alter CONTACT_ID position 4;
alter table WWW_USERS
alter PERSON_ID position 5;
alter table WWW_USERS
alter TYP position 6;
alter table WWW_USERS
alter PRAWA position 7;
alter table WWW_USERS
alter REG_DATE position 8;
alter table WWW_USERS
alter LAST_LOGIN_DATE position 9;
alter table WWW_USERS
alter LAST_LOGIN_FROM position 10;
alter table WWW_USERS
alter WYLACZONE position 11;
alter table WWW_USERS
alter POWOD_WYLACZENIA position 12;

ALTER TABLE WWW_USERS ADD PRACOWNIK_ID INTEGER DEFAULT 0;

ALTER TABLE WWW_USERS ADD OPERATOR_NAZWA STRING15_D COLLATE PXW_PLK;

ALTER TABLE WWW_USERS ADD MALPKA BOOLEAN_D DEFAULT 0 ;

UPDATE WWW_USERS SET MALPKA = 0;

ALTER TABLE WWW_USERS ADD AD_USER_ID INTEGER DEFAULT 0;

INSERT INTO WWW_USERS (ID,HASLO,LOGIN,CONTACT_ID,PERSON_ID,TYP,PRAWA,REG_DATE,LAST_LOGIN_DATE,LAST_LOGIN_FROM,WYLACZONE,POWOD_WYLACZENIA) VALUES (0,NULL,'Brak',0,0,0,0,NULL,'12-OCT-2007 20:24:20',NULL,1,'Nie mona sie zalogowac na to konto!');

alter table WWW_USERS
add constraint WWW_USERS_CONTACT_ID_FK
foreign key (CONTACT_ID)
references R3_CONTACTS(ID)
on delete CASCADE
on update CASCADE
using index WWW_USERS_CONTACT_ID_IND;

alter table WWW_USERS
add constraint WWW_USERS_PERSON_ID_FK
foreign key (PERSON_ID)
references R3_PERSONS(ID)
on delete CASCADE
on update CASCADE
using index WWW_USERS_PERSON_ID_IND;

alter table WWW_USERS
add constraint WWW_USERS_PRACOWNIK_ID_FK
foreign key (PRACOWNIK_ID)
references R3_CONTACTS(ID)
on delete CASCADE
on update CASCADE
using index WWW_USERS_PRACOWNIK_ID_IND;


CREATE INDEX WWW_USERS_AD_USER_ID_IND ON WWW_USERS (AD_USER_ID);
CREATE INDEX WWW_USERS_DATY_IND ON WWW_USERS (REG_DATE, LAST_LOGIN_DATE, LAST_LOGIN_FROM);
CREATE INDEX WWW_USERS_OP_NAZWA_IND ON WWW_USERS (OPERATOR_NAZWA);


/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/


CREATE GENERATOR WWW_POWIADOMIENIA_ID_GEN;

CREATE TABLE WWW_POWIADOMIENIA (
    ID          INTEGER NOT NULL,
    MAGAZYN_ID  INTEGER default 0,
    TYP         INTEGER default 0 NOT NULL,
    ADRES       STRING50_ISO_D NOT NULL /* STRING50_ISO_D = VARCHAR(50) */
);




/******************************************************************************/
/****                               Triggers                               ****/
/******************************************************************************/


SET TERM ^ ;


/******************************************************************************/
/****                         Triggers for tables                          ****/
/******************************************************************************/



/* Trigger: WWW_ZK_EMAILS_BI */
CREATE TRIGGER WWW_POWIADOMIENIA_BI FOR WWW_POWIADOMIENIA
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(WWW_POWIADOMIENIA_ID_GEN,1);
END
^


SET TERM ; ^


/* Privileges of roles */
GRANT ALL ON WWW_POWIADOMIENIA TO WWW_ROLE;

/******************************************************************************/
DROP TABLE WWW_STAN_UMOWNY;
DROP GENERATOR WWW_STAN_UMOWNY_ID_GEN;
CREATE GENERATOR WWW_STANY_UMOWNE_ID_GEN;

CREATE TABLE WWW_STANY_UMOWNY (
    ID        INTEGER NOT NULL,
    NAZWA     VARCHAR(20) NOT NULL,
    PROG      INTEGER,
    GRUPA_ID  INTEGER DEFAULT 0 NOT NULL,
    TOWAR_ID  INTEGER DEFAULT 0 NOT NULL,
    IMAGE     BOOLEAN_D /* BOOLEAN_D = SMALLINT DEFAULT 0 NOT NULL CHECK    (VALUE IN (0,1)) */
);

GRANT ALL ON WWW_STANY_UMOWNY TO WWW_ROLE;


ALTER TABLE WWW_GRUPYT_EXT ADD IMAGE BOOLEAN_D;
UPDATE WWW_GRUPYT_EXT SET IMAGE = 0;

ALTER TABLE WWW_GRUPYT ADD IMG STRING250_D COLLATE PXW_PLK;

ALTER TABLE WWW_GRUPYT ADD IMAGE BOOLEAN_D;
UPDATE WWW_GRUPYT SET IMAGE = 0;


ALTER TABLE WWW_GRUPYT_EXT ADD IMG STRING250_D COLLATE PXW_PLK;











/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/


CREATE GENERATOR WWW_CHAT_USERS_ID_GEN;

CREATE TABLE WWW_CHAT_USERS (
    ID           INTEGER NOT NULL,
    LOGIN        STRING60_ISO_D NOT NULL /* STRING60_ISO_D = VARCHAR(60) */,
    USER_ID      INTEGER,
    KONSULTANT   BOOLEAN_D /* BOOLEAN_D = SMALLINT DEFAULT 0 NOT NULL CHECK    (VALUE IN (0,1)) */,
    LOGIN_TIME   TIMESTAMP,
    ACTIVE_TIME  TIMESTAMP
);





/******************************************************************************/
/****                             Primary Keys                             ****/
/******************************************************************************/

ALTER TABLE WWW_CHAT_USERS ADD CONSTRAINT WWW_CHAT_USERS_PK PRIMARY KEY (ID);


/******************************************************************************/
/****                               Indices                                ****/
/******************************************************************************/

CREATE INDEX WWW_CHAT_USERS_USER_ID_IND ON WWW_CHAT_USERS (USER_ID);
CREATE INDEX WWW_CHAT_USERS_LOGIN_IND ON WWW_CHAT_USERS (LOGIN);


/******************************************************************************/
/****                               Triggers                               ****/
/******************************************************************************/


SET TERM ^ ;


/******************************************************************************/
/****                         Triggers for tables                          ****/
/******************************************************************************/



/* Trigger: WWW_CHAT_USERS_BI */
CREATE TRIGGER WWW_CHAT_USERS_BI FOR WWW_CHAT_USERS
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(WWW_CHAT_USERS_ID_GEN,1);
END
^


SET TERM ; ^



/******************************************************************************/
/****                              Privileges                              ****/
/******************************************************************************/

GRANT ALL ON WWW_CHAT_USERS TO WWW_ROLE;






/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/



CREATE TABLE WWW_CHAT (
    NADAWCA         INTEGER NOT NULL,
    ODBIORCA        INTEGER NOT NULL,
    DATA_WYSLANIA   TIMESTAMP NOT NULL,
    DATA_ODEBRANIA  TIMESTAMP,
    ODEBRANA        BOOLEAN_D NOT NULL /* BOOLEAN_D = SMALLINT DEFAULT 0 NOT NULL CHECK    (VALUE IN (0,1)) */,
    TRESC           STRING512_D NOT NULL /* STRING512_D = VARCHAR(512) */
);




/******************************************************************************/
/****                             Foreign Keys                             ****/
/******************************************************************************/

ALTER TABLE WWW_CHAT ADD CONSTRAINT WWW_CHAT_NADAWCA_FK FOREIGN KEY (NADAWCA) REFERENCES WWW_CHAT_USERS (ID) ON DELETE CASCADE ON UPDATE CASCADE;
ALTER TABLE WWW_CHAT ADD CONSTRAINT WWW_CHAT_ODBIORCA_FK FOREIGN KEY (ODBIORCA) REFERENCES WWW_CHAT_USERS (ID) ON DELETE CASCADE ON UPDATE CASCADE;


/******************************************************************************/
/****                               Indices                                ****/
/******************************************************************************/

CREATE INDEX WWW_CHAT_DATA_WYSLANIA_IND ON WWW_CHAT (DATA_WYSLANIA);


/******************************************************************************/
/****                              Privileges                              ****/
/******************************************************************************/

GRANT ALL ON WWW_CHAT TO WWW_ROLE;

CREATE DOMAIN KONTO_WWW_TYP_D AS SMALLINT NOT NULL CHECK (VALUE IN (0,1,2));
ALTER TABLE WWW_USERS ADD TYP KONTO_WWW_TYP_D DEFAULT 0 NOT NULL;
UPDATE WWW_USERS SET TYP = 0;

update RDB$RELATION_FIELDS set
RDB$FIELD_SOURCE = 'NAZWA_D',
RDB$NULL_FLAG = 1
where (RDB$FIELD_NAME = 'TOWAR_NAZWA') and
(RDB$RELATION_NAME = 'WWW_FAV_POZ');

alter table WWW_FAV_POZ add constraint WWW_FAV_POZ_FAV_ID_FK foreign key (FAV_ID) references WWW_FAV(ID) on delete CASCADE on update CASCADE;
alter table WWW_KOSZYK_POZ add constraint WWW_KOSZYK_KOSZYK_ID_FK foreign key (KOSZYK_ID) references WWW_KOSZYK(ID) on delete CASCADE on update CASCADE;
alter table WWW_KOSZYK add constraint WWW_KOSZYK_USER_ID_FK foreign key (USER_ID) references WWW_USERS(ID) on delete CASCADE on update CASCADE;

ALTER TABLE WWW_USERS_CONFIG DROP CONSTRAINT WWW_USERS_CONFIG_USER_ID_FK;
alter table WWW_USERS_CONFIG add constraint WWW_USERS_CONFIG_USER_ID_FK foreign key (USER_ID) references WWW_USERS(ID) on delete CASCADE on update CASCADE using index WWW_USERS_CONFIG_USER_ID_FK;

alter table WWW_KOMENTARZE add constraint WWW_KOMENTARZE_USER_ID_FK foreign key (USER_ID) references WWW_USERS(ID) on delete CASCADE on update CASCADE using index WWW_KOMENTARZE_USER_ID_FK;

alter table WWW_USERS
alter ID position 1;
alter table WWW_USERS
alter HASLO position 2;
alter table WWW_USERS
alter LOGIN position 3;
alter table WWW_USERS
alter CONTACT_ID position 4;
alter table WWW_USERS
alter PERSON_ID position 5;
alter table WWW_USERS
alter TYP position 6;
alter table WWW_USERS
alter PRAWA position 7;
alter table WWW_USERS
alter REG_DATE position 8;
alter table WWW_USERS
alter LAST_LOGIN_DATE position 9;
alter table WWW_USERS
alter ACTIVE_TIME position 10;
alter table WWW_USERS
alter SESSION_ID position 11;
alter table WWW_USERS
alter WYLACZONE position 12;
alter table WWW_USERS
alter POWOD_WYLACZENIA position 13;


ALTER TABLE WWW_LOG ALTER ERROR_NO TO NUMER;
ALTER TABLE WWW_LOG ALTER ERROR_PATH TO SCIEZKA;
ALTER TABLE WWW_LOG ALTER ERROR_FILE TO PLIK;
ALTER TABLE WWW_LOG ALTER ERROR_LINE TO LINIA;
ALTER TABLE WWW_LOG ALTER ERROR_STR TO STR;
ALTER TABLE WWW_LOG ALTER ERROR_DESC TO OPIS;
ALTER TABLE WWW_LOG ALTER ERROR_DATE TO DATA;
ALTER TABLE WWW_LOG ADD USER_ID INTEGER;




/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/


CREATE GENERATOR WWW_ERRORS_ID_GEN;

CREATE TABLE WWW_ERRORS(
    ID        INTEGER NOT NULL,
    NUMER     INTEGER,
    SCIEZKA   VARCHAR(256),
    PLIK      VARCHAR(32) CHARACTER SET ISO8859_2,
    LINIA     INTEGER,
    STR       VARCHAR(512),
    OPIS      BLOB SUB_TYPE 1 SEGMENT SIZE 80,
    DATA      TIMESTAMP,
    ADRES_IP  VARCHAR(16),
    USER_ID   INTEGER
);




/******************************************************************************/
/****                             Primary Keys                             ****/
/******************************************************************************/

ALTER TABLE WWW_ERRORS ADD CONSTRAINT WWW_ERRORS_PK PRIMARY KEY (ID);


/******************************************************************************/
/****                               Triggers                               ****/
/******************************************************************************/


SET TERM ^ ;


/******************************************************************************/
/****                         Triggers for tables                          ****/
/******************************************************************************/



/* Trigger: WWW_LOG_BI */
CREATE TRIGGER WWW_ERRORS_BI FOR WWW_ERRORS
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(WWW_ERRORS_ID_GEN,1);
END
^


SET TERM ; ^



/******************************************************************************/
/****                              Privileges                              ****/
/******************************************************************************/


/* Privileges of roles */
GRANT ALL ON WWW_ERRORS TO WWW_ROLE;





CREATE TABLE WWW_ONLINE (
    USER_ID      INTEGER DEFAULT 0 NOT NULL,
    SESSION_ID   VARCHAR(32) NOT NULL,
    FIRST_VISIT  TIMESTAMP,
    LAST_ACTIVE  TIMESTAMP
);




/******************************************************************************/
/****                          Unique Constraints                          ****/
/******************************************************************************/

ALTER TABLE WWW_ONLINE ADD CONSTRAINT WWW_ONLINE_SESSION_ID_UNQ UNIQUE (SESSION_ID)
USING INDEX WWW_ONLINE_SESSION_ID_IND;


/******************************************************************************/
/****                             Foreign Keys                             ****/
/******************************************************************************/

ALTER TABLE WWW_ONLINE ADD CONSTRAINT WWW_ONLINE_USER_ID_FK FOREIGN KEY (USER_ID) REFERENCES WWW_USERS (ID) ON DELETE CASCADE ON UPDATE CASCADE
  USING INDEX WWW_ONLINE_USER_ID_IND;


/******************************************************************************/
/****                               Indices                                ****/
/******************************************************************************/

CREATE INDEX WWW_ONLINE_LAST_ACTIVE_IND ON WWW_ONLINE (LAST_ACTIVE);


/* Fields descriptions */

DESCRIBE FIELD USER_ID TABLE WWW_ONLINE
'Jeli sessja jest dla zalogowanego uzytkownika to jest tutaj wpisany jego identyfikator z tabeli WWW_USERS';

DESCRIBE FIELD SESSION_ID TABLE WWW_ONLINE
'Jest to identyfikator sessji dla osoby ktora wchodzi na strone.';

DESCRIBE FIELD FIRST_VISIT TABLE WWW_ONLINE
'Jest to czas peiwrszego wejscia na strone.';

DESCRIBE FIELD LAST_ACTIVE TABLE WWW_ONLINE
'Jest to czas ostatniego odswiezenia strony, sluzacy do sprawdzenia czy jeszcze nie uplynal czas waznosci sessji, ktory jest ustawiany w panelu administracyjnym w sekcji: Ustawienia administarcyjne.';



/******************************************************************************/
/****                              Privileges                              ****/
/******************************************************************************/
/* Privileges of roles */
GRANT ALL ON WWW_ONLINE TO WWW_ROLE;



/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/



CREATE TABLE WWW_HISTORIA_CEN (
    TOWAR_ID     INTEGER NOT NULL,
    CENNIK_ID    INTEGER NOT NULL,
    CENA_STARA   CENA_D /* CENA_D = NUMERIC(15,4) DEFAULT 0 NOT NULL CHECK  (VALUE >=0) */,
    CENA_NOWA    CENA_D /* CENA_D = NUMERIC(15,4) DEFAULT 0 NOT NULL CHECK  (VALUE >=0) */,
    CENAB_STARA  CENA_D /* CENA_D = NUMERIC(15,4) DEFAULT 0 NOT NULL CHECK  (VALUE >=0) */,
    CENAB_NOWA   CENA_D /* CENA_D = NUMERIC(15,4) DEFAULT 0 NOT NULL CHECK  (VALUE >=0) */,
    DATA_ZMIANY  TIMESTAMP NOT NULL
);




/******************************************************************************/
/****                               Indices                                ****/
/******************************************************************************/

CREATE INDEX WWW_HISTORIA_CEN_TOWAR_ID_IND ON WWW_HISTORIA_CEN (TOWAR_ID);
CREATE INDEX WWW_HISTORIA_CEN_ZMIANA_IND ON WWW_HISTORIA_CEN (DATA_ZMIANY);


/* Fields descriptions */

DESCRIBE FIELD CENA_STARA TABLE WWW_HISTORIA_CEN
'Wzr typu dla pl zawierajcych cen';

DESCRIBE FIELD CENA_NOWA TABLE WWW_HISTORIA_CEN
'Wzr typu dla pl zawierajcych cen';

DESCRIBE FIELD CENAB_STARA TABLE WWW_HISTORIA_CEN
'Wzr typu dla pl zawierajcych cen';

DESCRIBE FIELD CENAB_NOWA TABLE WWW_HISTORIA_CEN
'Wzr typu dla pl zawierajcych cen';



/******************************************************************************/
/****                              Privileges                              ****/
/******************************************************************************/


/* Privileges of roles */
GRANT ALL ON WWW_HISTORIA_CEN TO WWW_ROLE;




















/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/


CREATE GENERATOR WWW_SPOSOBY_DOSTAWY_ID_GEN;

CREATE TABLE WWW_SPOSOBY_DOSTAWY (
    ID          INTEGER NOT NULL,
    NAZWA       VARCHAR(30),
    USLUGA      INTEGER DEFAULT NULL,
    DOMYSLNY    BOOLEAN_D DEFAULT 0 NOT NULL /* BOOLEAN_D = SMALLINT DEFAULT 0 NOT NULL CHECK    (VALUE IN (0,1)) */,
    WYSWIETLAJ  BOOLEAN_D DEFAULT 1 NOT NULL /* BOOLEAN_D = SMALLINT DEFAULT 0 NOT NULL CHECK    (VALUE IN (0,1)) */,
    OPIS        STRING250_ISO_D /* STRING250_ISO_D = VARCHAR(250) */
);




/******************************************************************************/
/****                             Primary Keys                             ****/
/******************************************************************************/

ALTER TABLE WWW_SPOSOBY_DOSTAWY ADD CONSTRAINT WWW_SPOSOBY_DOSTAWY_PK PRIMARY KEY (ID);


/******************************************************************************/
/****                             Foreign Keys                             ****/
/******************************************************************************/

ALTER TABLE WWW_SPOSOBY_DOSTAWY ADD CONSTRAINT WWW_SPOSOBY_DOSTAWY_USLUGA_FK FOREIGN KEY (USLUGA) REFERENCES GM_TOWARY (ID) ON DELETE CASCADE ON UPDATE CASCADE
  USING INDEX WWW_SPOSOBY_DOSTAWY_USLUGA_IND;


/******************************************************************************/
/****                               Indices                                ****/
/******************************************************************************/

CREATE INDEX WWW_SPOSOBY_DOSTAWY_NAZWA_IND ON WWW_SPOSOBY_DOSTAWY (NAZWA);


/******************************************************************************/
/****                               Triggers                               ****/
/******************************************************************************/


SET TERM ^ ;


/******************************************************************************/
/****                         Triggers for tables                          ****/
/******************************************************************************/



/* Trigger: WWW_SPOSOBY_DOSTAWY_BD0 */
CREATE TRIGGER WWW_SPOSOBY_DOSTAWY_BD0 FOR WWW_SPOSOBY_DOSTAWY
ACTIVE BEFORE DELETE POSITION 0
AS
begin
  /* Trigger text */
  if  (old.id < 2) then EXCEPTION WWW_SPOSOBY_DOSTAWY_BD_EXC;
end
^


/* Trigger: WWW_SPOSOBY_DOSTAWY_BI */
CREATE TRIGGER WWW_SPOSOBY_DOSTAWY_BI FOR WWW_SPOSOBY_DOSTAWY
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN NEW.ID = GEN_ID(WWW_SPOSOBY_DOSTAWY_ID_GEN,1);
END
^


SET TERM ; ^



/******************************************************************************/
/****                              Privileges                              ****/
/******************************************************************************/


/* Privileges of roles */
GRANT ALL ON WWW_SPOSOBY_DOSTAWY TO WWW_ROLE;




/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/


CREATE GENERATOR WWW_PRZESYLKI_ID_GEN;

CREATE TABLE WWW_PRZESYLKI (
    ID              INTEGER NOT NULL,
    SP_DOST_ID      INTEGER NOT NULL,
    NUM             SMALLINT NOT NULL,
    NAZWA           VARCHAR(25) NOT NULL,
    KOSZT           CENA_D /* CENA_D = NUMERIC(15,4) DEFAULT 0 NOT NULL CHECK  (VALUE >=0) */,
    GRATIS_KWOTA    CENAN_D /* CENAN_D = NUMERIC(15,4) NOT NULL */,
    POBRANIE        BOOLEAN_D /* BOOLEAN_D = SMALLINT DEFAULT 0 NOT NULL CHECK    (VALUE IN (0,1)) */,
    POBRANIE_KOSZT  CENA_D /* CENA_D = NUMERIC(15,4) DEFAULT 0 NOT NULL CHECK  (VALUE >=0) */,
    OPIS            STRING250_D /* STRING250_D = VARCHAR(250) */
);




/******************************************************************************/
/****                             Primary Keys                             ****/
/******************************************************************************/

ALTER TABLE WWW_PRZESYLKI ADD CONSTRAINT WWW_PRZESYLKI_PK PRIMARY KEY (ID)
USING INDEX WWW_PRZESYLKI_ID_IND;


/******************************************************************************/
/****                             Foreign Keys                             ****/
/******************************************************************************/

ALTER TABLE WWW_PRZESYLKI ADD CONSTRAINT WWW_PRZESYLKI_SP_DOST_FK FOREIGN KEY (SP_DOST_ID) REFERENCES WWW_SPOSOBY_DOSTAWY (ID) ON DELETE CASCADE ON UPDATE CASCADE
  USING INDEX WWW_PRZESYLKI_SP_DOST_IND;


/******************************************************************************/
/****                               Indices                                ****/
/******************************************************************************/

CREATE INDEX WWW_PRZESYLKI_NAZWA_IND ON WWW_PRZESYLKI (NAZWA);


/******************************************************************************/
/****                               Triggers                               ****/
/******************************************************************************/


SET TERM ^ ;


/******************************************************************************/
/****                         Triggers for tables                          ****/
/******************************************************************************/



/* Trigger: WWW_PRZESYLKI_BI */
CREATE TRIGGER WWW_PRZESYLKI_BI FOR WWW_PRZESYLKI
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(WWW_PRZESYLKI_ID_GEN,1);
END
^


SET TERM ; ^



/* Fields descriptions */

DESCRIBE FIELD KOSZT TABLE WWW_PRZESYLKI
'Wzr typu dla pl zawierajcych cen';

DESCRIBE FIELD GRATIS_KWOTA TABLE WWW_PRZESYLKI
'Wzr typu dla pl zawierajcych cen (pole musi posiada warto)';

DESCRIBE FIELD POBRANIE TABLE WWW_PRZESYLKI
'Wzr typu dla pl zawierajcych warto logiczn: tak lub nie';

DESCRIBE FIELD POBRANIE_KOSZT TABLE WWW_PRZESYLKI
'Wzr typu dla pl zawierajcych cen';



/******************************************************************************/
/****                              Privileges                              ****/
/******************************************************************************/


/* Privileges of roles */
GRANT ALL ON WWW_PRZESYLKI TO WWW_ROLE;




/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/



CREATE TABLE WWW_PRZESYLKI_OPCJE (
    PRZESYLKA_ID  INTEGER NOT NULL,
    NUM           SMALLINT NOT NULL,
    GRUPA         STRING10_D COLLATE PXW_PLK /* STRING10_D = VARCHAR(10) */,
    NAZWA         STRING30_D NOT NULL /* STRING30_D = VARCHAR(30) */,
    KOSZT         CENAN_D NOT NULL /* CENAN_D = NUMERIC(15,4) NOT NULL */,
    OPIS          STRING250_D /* STRING250_D = VARCHAR(250) */
);




/******************************************************************************/
/****                          Unique Constraints                          ****/
/******************************************************************************/

ALTER TABLE WWW_PRZESYLKI_OPCJE ADD CONSTRAINT WWW_PRZESYLKIO_PRZESYL_NUM_UNQ UNIQUE (PRZESYLKA_ID, NUM)
USING INDEX WWW_PRZESYLKIO_PRZESYL_NUM_IND;


/******************************************************************************/
/****                             Foreign Keys                             ****/
/******************************************************************************/

ALTER TABLE WWW_PRZESYLKI_OPCJE ADD CONSTRAINT WWW_PRZESYLKIO_PRZESYL_FK FOREIGN KEY (PRZESYLKA_ID) REFERENCES WWW_PRZESYLKI (ID) ON DELETE CASCADE ON UPDATE CASCADE
  USING INDEX WWW_PRZESYLKIO_PRZESYL_IND;


/******************************************************************************/
/****                               Indices                                ****/
/******************************************************************************/

CREATE INDEX WWW_PRZESYLKIO_NAZWA_IND ON WWW_PRZESYLKI_OPCJE (NAZWA);


/* Fields descriptions */

DESCRIBE FIELD KOSZT TABLE WWW_PRZESYLKI_OPCJE
'Wzr typu dla pl zawierajcych cen (pole musi posiada warto)';



/******************************************************************************/
/****                              Privileges                              ****/
/******************************************************************************/


/* Privileges of roles */
GRANT ALL ON WWW_PRZESYLKI_OPCJE TO WWW_ROLE;

/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/



CREATE TABLE WWW_PRZESYLKI_KOSZTY (
    PRZESYLKA_ID  INTEGER NOT NULL,
    NUM           SMALLINT NOT NULL,
    WAGA_OD       INTEGER NOT NULL,
    WAGA_DO       INTEGER NOT NULL,
    KOSZT         CENAN_D NOT NULL /* CENAN_D = NUMERIC(15,4) NOT NULL */
);




/******************************************************************************/
/****                          Unique Constraints                          ****/
/******************************************************************************/

ALTER TABLE WWW_PRZESYLKI_KOSZTY ADD CONSTRAINT WWW_PRZESYLKI_KOSZTY_UNQ UNIQUE (PRZESYLKA_ID, NUM)
USING INDEX WWW_PRZESYLKI_KOSZTY_NUM_IND;


/******************************************************************************/
/****                             Foreign Keys                             ****/
/******************************************************************************/

ALTER TABLE WWW_PRZESYLKI_KOSZTY ADD CONSTRAINT WWW_PRZESYLKIK_PRZESYL_FK FOREIGN KEY (PRZESYLKA_ID) REFERENCES WWW_PRZESYLKI (ID) ON DELETE CASCADE ON UPDATE CASCADE
  USING INDEX WWW_PRZESYLKIK_PRZESYL_IND;


/******************************************************************************/
/****                               Indices                                ****/
/******************************************************************************/

CREATE INDEX WWW_PRZESYLKIK_WAGA_DO_IND ON WWW_PRZESYLKI_KOSZTY (WAGA_DO);
CREATE INDEX WWW_PRZESYLKIK_WAGA_OD_IND ON WWW_PRZESYLKI_KOSZTY (WAGA_OD);


/* Fields descriptions */

DESCRIBE FIELD KOSZT TABLE WWW_PRZESYLKI_KOSZTY
'Wzr typu dla pl zawierajcych cen (pole musi posiada warto)';



/******************************************************************************/
/****                              Privileges                              ****/
/******************************************************************************/


/* Privileges of roles */
GRANT ALL ON WWW_PRZESYLKI_KOSZTY TO WWW_ROLE;



/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/



CREATE TABLE WWW_STATS (
    TOWAR_ID    INTEGER NOT NULL,
    WYSWIETLEN  INTEGER NOT NULL,
    DATA        DATE NOT NULL,
    ROK         SMALLINT NOT NULL,
    MIESIAC     SMALLINT NOT NULL,
    DZIEN       SMALLINT NOT NULL
);




/******************************************************************************/
/****                             Foreign Keys                             ****/
/******************************************************************************/

ALTER TABLE WWW_STATS ADD CONSTRAINT WWW_STATS_TOWAR_ID_FK FOREIGN KEY (TOWAR_ID) REFERENCES GM_TOWARY (ID);


/******************************************************************************/
/****                               Indices                                ****/
/******************************************************************************/

CREATE INDEX WWW_STATS_DATA_IND ON WWW_STATS (DATA);
CREATE INDEX WWW_STATS_GLOWNY_IND ON WWW_STATS (TOWAR_ID, ROK, MIESIAC, DZIEN);
CREATE INDEX WWW_STATS_WYSWIETLEN_IND ON WWW_STATS (WYSWIETLEN);


/******************************************************************************/
/****                              Privileges                              ****/
/******************************************************************************/


/* Privileges of roles */
GRANT ALL ON WWW_STATS TO WWW_ROLE;









/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/


CREATE GENERATOR WWW_RABATY_ID_GEN;

CREATE TABLE WWW_RABATY (
    ID            INTEGER NOT NULL,
    CONTACT_ID    INTEGER NOT NULL,
    WARTOSC       PROCENT_D /* PROCENT_D = NUMERIC(6,2) DEFAULT 0 CHECK  ((VALUE >=0) OR (VALUE IS NULL)) */,
    CENA_OD       D_KWOTA /* D_KWOTA = NUMERIC(18,2) */,
    RABAT_ID      INTEGER,
    PRODUCENT_ID  INTEGER,
    GRUPAT_ID     INTEGER
);




/******************************************************************************/
/****                          Unique Constraints                          ****/
/******************************************************************************/

ALTER TABLE WWW_RABATY ADD CONSTRAINT WWW_RABATY_CONTACT_GRUPA_UNQ UNIQUE (CONTACT_ID, GRUPAT_ID)
USING INDEX WWW_RABATY_CONTACT_GRUPA_IND;
ALTER TABLE WWW_RABATY ADD CONSTRAINT WWW_RABATY_CONTACT_PROD_UNQ UNIQUE (CONTACT_ID, PRODUCENT_ID)
USING INDEX WWW_RABATY_CONTACT_PROD_IND;


/******************************************************************************/
/****                             Primary Keys                             ****/
/******************************************************************************/

ALTER TABLE WWW_RABATY ADD CONSTRAINT WWW_RABATY_ID_PK PRIMARY KEY (ID)
USING INDEX WWW_RABATY_ID_IND;


/******************************************************************************/
/****                             Foreign Keys                             ****/
/******************************************************************************/

ALTER TABLE WWW_RABATY ADD CONSTRAINT WWW_RABATY_CONTACT_ID_FK FOREIGN KEY (CONTACT_ID) REFERENCES R3_CONTACTS (ID) ON DELETE CASCADE ON UPDATE CASCADE
  USING INDEX WWW_RABATY_CONTACT_ID_IND;
ALTER TABLE WWW_RABATY ADD CONSTRAINT WWW_RABATY_GRUPAT_ID_FK FOREIGN KEY (GRUPAT_ID) REFERENCES GM_GRUPYT (ID) ON DELETE CASCADE ON UPDATE CASCADE
  USING INDEX WWW_RABATY_GRUPAT_ID_IND;
ALTER TABLE WWW_RABATY ADD CONSTRAINT WWW_RABATY_PRODUCENT_ID_FK FOREIGN KEY (PRODUCENT_ID) REFERENCES R3_CONTACTS (ID) ON DELETE CASCADE ON UPDATE CASCADE
  USING INDEX WWW_RABATY_PRODUCENT_ID_IND;
ALTER TABLE WWW_RABATY ADD CONSTRAINT WWW_RABATY_RABAT_ID_FK FOREIGN KEY (RABAT_ID) REFERENCES GM_RABATY (ID) ON DELETE CASCADE ON UPDATE CASCADE
  USING INDEX WWW_RABATY_RABAT_ID_IND;


/******************************************************************************/
/****                               Triggers                               ****/
/******************************************************************************/


SET TERM ^ ;


/******************************************************************************/
/****                         Triggers for tables                          ****/
/******************************************************************************/



/* Trigger: WWW_RABATY_BI */
CREATE TRIGGER WWW_RABATY_BI FOR WWW_RABATY
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(WWW_RABATY_ID_GEN,1);
END
^


SET TERM ; ^



/* Fields descriptions */

DESCRIBE FIELD WARTOSC TABLE WWW_RABATY
'Wzr typu dla pl zawierajcych warto procentow';

DESCRIBE FIELD CENA_OD TABLE WWW_RABATY
'Pole przechowujce kwot z dokadnoci do dwoch miejsc po prtzecinku';



/******************************************************************************/
/****                              Privileges                              ****/
/******************************************************************************/


/* Privileges of roles */
GRANT ALL ON WWW_RABATY TO WWW_ROLE;




/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/


CREATE GENERATOR WWW_STANY_UMOWNE_ID_GEN;

CREATE TABLE WWW_STANY_UMOWNE (
    ID            INTEGER NOT NULL,
    NAZWA         VARCHAR(20) NOT NULL,
    RZECZYWISTY   BOOLEAN_D /* BOOLEAN_D = SMALLINT DEFAULT 0 NOT NULL CHECK    (VALUE IN (0,1)) */,
    PROG_DOLNY    ILOSC_NULL_D /* ILOSC_NULL_D = NUMERIC(15,4) DEFAULT 0 CHECK  (VALUE >=0 OR VALUE IS NULL) */,
    PROG_GORNY    ILOSC_NULL_D /* ILOSC_NULL_D = NUMERIC(15,4) DEFAULT 0 CHECK  (VALUE >=0 OR VALUE IS NULL) */,
    GRUPA_ID      INTEGER DEFAULT 0 NOT NULL,
    GRUPA_EXT_ID  SMALLINT,
    TOWAR_ID      INTEGER DEFAULT 0 NOT NULL,
    ICO           BOOLEAN_D /* BOOLEAN_D = SMALLINT DEFAULT 0 NOT NULL CHECK    (VALUE IN (0,1)) */,
    ICO_NAME      VARCHAR(128),
    ICO_EXT       VARCHAR(4),
    ICO_WIDTH     SMALLINT,
    ICO_HEIGHT    SMALLINT
);




/******************************************************************************/
/****                             Primary Keys                             ****/
/******************************************************************************/

ALTER TABLE WWW_STANY_UMOWNE ADD CONSTRAINT WWW_STANY_UMOWNE_PK PRIMARY KEY (ID)
USING INDEX WWW_STANY_UMOWNE_ID_IND;


/******************************************************************************/
/****                               Indices                                ****/
/******************************************************************************/

CREATE INDEX WWW_STANY_UMOWNE_PD_IND ON WWW_STANY_UMOWNE (PROG_DOLNY);
CREATE INDEX WWW_STANY_UMOWNE_PG_IND ON WWW_STANY_UMOWNE (PROG_GORNY);


/******************************************************************************/
/****                               Triggers                               ****/
/******************************************************************************/


SET TERM ^ ;


/******************************************************************************/
/****                         Triggers for tables                          ****/
/******************************************************************************/



/* Trigger: WWW_STANY_UMOWNE_BI */
CREATE TRIGGER WWW_STANY_UMOWNE_BI FOR WWW_STANY_UMOWNE
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID IS NULL) THEN
    NEW.ID = GEN_ID(WWW_STANY_UMOWNE_ID_GEN,1);
END
^


SET TERM ; ^



/******************************************************************************/
/****                              Privileges                              ****/
/******************************************************************************/


/* Privileges of roles */
GRANT SELECT, INSERT, UPDATE, DELETE ON WWW_STANY_UMOWNE TO WWW_ROLE;



CREATE INDEX WWW_UWAGI_DATA_IND
ON WWW_UWAGI (DATA);


CREATE INDEX WWW_UWAGI_EMAIL_IND
ON WWW_UWAGI (EMAIL);

CREATE INDEX WWW_UWAGI_PODPIS_IND
ON WWW_UWAGI (PODPIS);

CREATE INDEX WWW_KOSZYK_NAZWA_IND
ON WWW_KOSZYK (NAZWA);

CREATE INDEX WWW_FAV_NAZWA_IND
ON WWW_FAV (NAZWA);

CREATE INDEX WWW_FAV_POZ_TOWAR_NAZWA_IND ON WWW_FAV_POZ (TOWAR_NAZWA);

CREATE INDEX WWW_LOG_ADRES_IP_IND ON WWW_LOG (ADRES_IP);
CREATE INDEX WWW_LOG_DATA_IND ON WWW_LOG (DATA);
CREATE INDEX WWW_LOG_NUMER_IND ON WWW_LOG (NUMER);
CREATE INDEX WWW_LOG_PLIK_IND ON WWW_LOG (PLIK);


CREATE INDEX WWW_GRUPYT_ID_PARENT_IND ON WWW_GRUPYT (ID_PARENT);
CREATE INDEX WWW_GRUPYT_NAZWA_IND ON WWW_GRUPYT (NAZWA);

CREATE INDEX WWW_GRUPYT_EXT_ID_PARENT_IND ON WWW_GRUPYT_EXT (ID_PARENT);
CREATE INDEX WWW_GRUPYT_EXT_NAZWA_IND ON WWW_GRUPYT_EXT (NAZWA);
